
; *****************************************************************************
;
;                              F L O P P Y
;                    Nadstavba pro obsluhu disketovch mechanik
;
; *****************************************************************************

;DEBUG    equ       1                        ; pepna pro ladn

; ------ definice registr v zsobnku

RegAX    EQU       word ptr ss:[bp+0]
 RegAL   EQU       byte ptr ss:[bp+0]
 RegAH   EQU       byte ptr ss:[bp+1]
RegBX    EQU       word ptr ss:[bp+2]
 RegBL   EQU       byte ptr ss:[bp+2]
 RegBH   EQU       byte ptr ss:[bp+3]
RegCX    EQU       word ptr ss:[bp+4]
 RegCL   EQU       byte ptr ss:[bp+4]
 RegCH   EQU       byte ptr ss:[bp+5]
RegDX    EQU       word ptr ss:[bp+6]
 RegDL   EQU       byte ptr ss:[bp+6]
 RegDH   EQU       byte ptr ss:[bp+7]
RegSI    EQU       word ptr ss:[bp+8]
RegDI    EQU       word ptr ss:[bp+10]
RegDS    EQU       word ptr ss:[bp+12]
RegES    EQU       word ptr ss:[bp+14]
RegBP    EQU       word ptr ss:[bp+16]
RegIP    EQU       word ptr ss:[bp+18]
RegCS    EQU       word ptr ss:[bp+20]
RegFlag  EQU       word ptr ss:[bp+22]

; -----------------------------------------------------------------------------
;        Rezidentn st programu
; -----------------------------------------------------------------------------

code     segment
         assume    cs:code,ds:code
         org       100h

Start:   jmp       Init                     ; inicializace programu

Identif  db        'FLOPPY V1.20'           ; identifikace ovladae
Identif0 label     byte

                                          ;* tabulka definic disk
DefDisk  db        0                        ; 0:
         db        0                        ; 1:
         db        0                        ; 2:
         db        0                        ; 3:

adrport1 dw        3f0h                     ; adresa adie #1
adrport2 dw        370h                     ; adresa adie #2

WaitAT   db        0                        ; 1=pznak oznamovn ekn AT
TimAT    db        0                        ; 1=pznak asovae AT

par40    db        0                        ; 1=pznak obsluhy INT 40h

old40    dd        0                        ; pvodn obsluha INT 40h
old08    dd        0                        ; pvodn obsluha INT 08h

Counter  db        0                        ; ta pro dlouh asy
Counter2 db        0                        ; ta asu pro ten ID

; ------ data pro adi #2 (adresa 370h)

ParCtr2  db        0                        ; 1=pznak instalace adie #2

                                          ;* 003eh
Rekalib  db        0                        ; pznak rekalibrace disk 2 a 3
                                          ;* 003fh
Motors   db        0                        ; pznaky motor disk 2 a 3
                                          ;* 0041h
LastStat db        0                        ; status posledn diskov operace
                                          ;* 0042h
Stat     db        7 dup(0)                 ; status adie


                                          ;* 008bh
LastRate db        0                        ; posledn nastaven penos.rychlost
MaxRate  db        0                        ; maximln penosov rychlost

                                          ;* 008fh
Stat2    db        0                        ; stavov bajt disku 2
Stat3    db        0                        ; stavov bajt disku 3


                                          ;* 0090h
Med2     db        0                        ; stav mdia disku 2
                                          ;* 0091h
Med3     db        0                        ; stav mdia disku 3


                                          ;* 0094h
Stopa2   db        0                        ; aktuln stopa disku 2
Stopa3   db        0                        ; aktuln stopa disku 3


; *****************************************************************************
;
;        Obsluha INT 08h
;
; *****************************************************************************

PUBLIC   Int08
Int08    PROC      FAR

         pushf
         call      dword ptr cs:[Old08]     ; pvodn obsluha INT 08h

; ------ obsluha tae dlouhho asu

         cmp       byte ptr cs:[Counter],0  ; je nco v tai asu ?
         je        Int080                   ; v tai asu nic nen
         dec       byte ptr cs:[Counter]    ; snen tae asu

; ------ obsluha tae pro ten ID

Int080:  cmp       byte ptr cs:[Counter2],0 ; je nco v tai asu ?
         je        Int083                   ; v tai asu nic nen
         dec       byte ptr cs:[Counter2]   ; snen tae asu

; ------ obsluha vypnut motor mechanik portu #2

Int083:
         push      ax
         push      dx
         push      ds
         xor       ax,ax
         mov       ds,ax
         cmp       byte ptr ds:[440h],0     ; je dosaeno 0 tae motor ?
         jne       Int082                   ; nen 0 tae motor
         cmp       byte ptr cs:[ParCtr2],0  ; je adi 2 nainstalovn ?
         je        Int082                   ; adi 2 nen nainstalovn
         mov       dx,cs:[AdrPort2]
         add       dx,2                     ; dic registr motor adie #2
         mov       al,0ch                   ; bajt pro vypnut motor
         out       dx,al                    ; vypnut motor
Int082:  pop       ds
         pop       dx
         pop       ax

Int081:  iret

Int08    ENDP


; *****************************************************************************
;        Data pro INT 40h
; *****************************************************************************

; -----------------------------------------------------------------------------
;        Tabulky disketovch parametr
; -----------------------------------------------------------------------------

TabDisk  label     byte                     ; (1):
Disk1:                                     ; mechanika 360 KB, disketa 360 KB
                                            db   0dfh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   9         ; 4: poet sektor na stopu
                                            db   42        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   80        ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   39        ; 11: posledn stopa
                                            db   80h       ; 12: penosov rychlost 250K/s

                                            ; (2):
Disk2:                                      ; mechanika 1.2 MB, disketa 360 KB
                                            db   0dfh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   9         ; 4: poet sektor na stopu
                                            db   42        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   80        ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   39        ; 11: posledn stopa
                                            db   40h       ; 12: penosov rychlost 300K/s

                                            ; (2 zvdojen):
Disk3:                                      ; mechanika 1.2 MB, disketa 1.2 MB
                                            db   0dfh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   15        ; 4: poet sektor na stopu
                                            db   27        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   84        ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   79        ; 11: posledn stopa
                                            db   0         ; 12: penosov rychlost 500K/s

                                            ; (3):
Disk4:                                      ; mechanika 720 KB, disketa 720 KB
                                            db   0dfh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   9         ; 4: poet sektor na stopu
                                            db   42        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   80        ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   79        ; 11: posledn stopa
                                            db   80h       ; 12: penosov rychlost 250 k/s

                                            ; (4):
Disk5:                                      ; mechanika 1.44 MB, disketa 720 KB
                                            db   0dfh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   9         ; 4: poet sektor na stopu
                                            db   42        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   80        ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   79        ; 11: posledn stopa
                                            db   80h       ; 12: penosov rychlost 250 k/s

                                            ; (4 zdvojen):
Disk6:                                      ; mechanika 1.44 MB, disketa 1.44 MB
                                            db   0afh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   18        ; 4: poet sektor na stopu
                                            db   27        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   108       ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   79        ; 11: posledn stopa
                                            db   0         ; 12: penosov rychlost 500 k/s

Disk7:                                      ; mechanika 1.2 MB, disketa 720 KB
                                            db   0dfh      ; 0: rychlost krokovn, zvednut hlavy
                                            db   2         ; 1: sputn ptlaku hlavy
                                            db   37        ; 2: as pro vypnut motoru
                                            db   2         ; 3: velikost sektoru
                                            db   9         ; 4: poet sektor na stopu
                                            db   42        ; 5: mezisekt. mezera ten/zpis
                                            db   255       ; 6: dlka penench dat
                                            db   80        ; 7: mezisekt. mezera formtovn
                                            db   0f6h      ; 8: plnic znak formtovn
                                            db   15        ; 9: doba ustlen hlav
                                            db   8         ; 10: doba pro rozbh motoru
                                            db   79        ; 11: posledn stopa
                                            db   40h       ; 12: penosov rychlost 500K/s

; *****************************************************************************
;
;        Obsluha disketovch mechanik INT 40h
;
; *****************************************************************************

PUBLIC   Int40
Int40    PROC      FAR

; ------ schova registr

                                            ; F  ss:[bp+22]
                                            ; CS ss:[bp+20]
                                            ; IP ss:[bp+18]
         push      bp                       ; BP ss:[bp+16]
         push      es                       ; ES ss:[bp+14]
         push      ds                       ; DS ss:[bp+12]
         push      di                       ; DI ss:[bp+10]
         push      si                       ; SI ss:[bp+8]
         push      dx                       ; DX ss:[bp+6]
         push      cx                       ; CX ss:[bp+4]
         push      bx                       ; BX ss:[bp+2]
         push      ax                       ; AX ss:[bp+0]

         cld                                ; smr nahoru
         sti                                ; povolen peruen
         mov       bp,sp                    ; ukazatel registr v zsobnku
         or        RegFlag,200h             ; nastaven pznaku IF

; ------ inicializace segment

         push      cs
         pop       ds                       ; DS <- CS
         xor       si,si
         mov       es,si                    ; ES <- 0

; ------ kontrola maximlnho sla funkce

         cmp       ah,18h                   ; maximln slo funkce
         jbe       Int401                   ; slo funkce je OK
         mov       ah,14h                   ; nhrada - nepovolen funkce

; ------ kontrola maximlnho sla disku

Int401:  cmp       ah,1                     ; je funkce 0 nebo 1 ?
         jbe       Int402                   ; je funkce 0 nebo 1 - nen kontrola
         cmp       ah,8                     ; je funkce 8 - poskytnut param. ?
         je        Int402                   ; je funkce 8 - zatm se nekontrol.
         cmp       dl,4                     ; pekroeno max. slo disku ?
         jb        Int402                   ; slo disku je OK
         mov       ah,14h                   ; nhrada - nepovolen funkce

; ------ pednastaven registr

Int402:  mov       bl,dl                    ; slo poadovanho disku

; ------ proveden obsluhy funkce

Int403:  xchg      ah,al                    ; AL <- slo funkce
         xor       ah,ah                    ; AH <- 0
         mov       si,ax                    ; SI <- slo funkce
         add       si,si                    ; slo funkce * 2
         call      word ptr ds:[si+TabSkok] ; proveden obsluhy funkce

; ------ konverze novho formtu dat na star

Int407:  mov       bl,RegDL                 ; slo disku
         call      XlatOld                  ; pevod novho formtu na star
         cmp       RegAH,15h                ; je funkce 15h
         je        Int40a                   ; je funkce 15h

; ------ nastaven pznaku chyby operace

         mov       byte ptr es:[441h],ah    ; nvratov kd
         or        RegFlag,1                ; nastaven pznaku chyby CY
         or        ah,ah                    ; byla chyba operace ?
         jnz       Int40b                   ; byla chyba operace

; ------ operace probhla OK, nastaven nvratovho kdu

Int40a:  and       RegFlag,not 1            ; nulovn pznaku CF
Int40b:  mov       RegAH,ah                 ; nastaven nvratovho kdu

; ------ nastaven tae pro vypnut motoru

         mov       al,2
         call      GetPar                   ; poskytnut parametru 2
         call      SetMOff                  ; nastaven ta pro vypnut mot.

; ------ nvrat registr

         pop       ax
         pop       bx
         pop       cx
         pop       dx
         pop       si
         pop       di
         pop       ds
         pop       es
         pop       bp
         iret

Int40    ENDP

; -----------------------------------------------------------------------------
;        Chybn zadn povelu
; -----------------------------------------------------------------------------

Chyba:   mov       ah,1
         ret

; -----------------------------------------------------------------------------
;        Tabulka adres obsluh funkc
; -----------------------------------------------------------------------------

TabSkok  label     word
         dw        offset Funkce00          ; funkce 00h reset diskety
         dw        offset Funkce01          ; funkce 01h poskytnut stavu
         dw        offset Funkce02          ; funkce 02h ten sektor
         dw        offset Funkce03          ; funkce 03h zpis sektor
         dw        offset Funkce04          ; funkce 04h verifikace sektor
         dw        offset Funkce05          ; funkce 05h formtovn stopy
         dw        offset Chyba             ; funkce 06h
         dw        offset Chyba             ; funkce 07h
         dw        offset Funkce08          ; funkce 08h poskytnut disk.par.
         dw        offset Chyba             ; funkce 09h
         dw        offset Funkce0a          ; funkce 0ah nalezen sektor
         dw        offset Chyba             ; funkce 0bh
         dw        offset Funkce0c          ; funkce 0ch vystaven na vlec
         dw        offset Chyba             ; funkce 0dh
         dw        offset Chyba             ; funkce 0eh
         dw        offset Chyba             ; funkce 0fh
         dw        offset Funkce10          ; funkce 10h test na pipravenost
         dw        offset Chyba             ; funkce 11h
         dw        offset Chyba             ; funkce 12h
         dw        offset Chyba             ; funkce 13h
         dw        offset Chyba             ; funkce 14h
         dw        offset Funkce15          ; funkce 15h ten typu DASD
         dw        offset Funkce16          ; funkce 16h status vmny
         dw        offset Funkce17          ; funkce 17h nastaven DASD
         dw        offset Funkce18          ; funkce 18h nastaven mdia

; -----------------------------------------------------------------------------
;        Funkce 00h - resetovn diskovho systmu
; -----------------------------------------------------------------------------

PUBLIC   Funkce00
Funkce00 PROC      NEAR

         cmp       byte ptr ds:[ParCtr2],0  ; je nainstalovn adi #2 ?
         je        Fnc001                   ; adi #2 nen nainstalovn
         mov       bl,2
         call      DiskRes
Fnc001:  xor       bl,bl
         call      DiskRes
         ret

Funkce00 ENDP

; -----------------------------------------------------------------------------
;        Funkce 01h - poskytnut stavu posledn diskov operace
; -----------------------------------------------------------------------------

PUBLIC   Funkce01
Funkce01 PROC      NEAR

         mov       ah,es:[441h]             ; kd posledn diskov operace
         ret

Funkce01 ENDP

; -----------------------------------------------------------------------------
;        Funkce 2, 3, 4 - Operace ten, zpis a verifikace
; -----------------------------------------------------------------------------
; - kontrola zadn disku
; - zapnut motoru
; - pi neznmm mdiu se nastav poten a koncov rychlost
;   Opakuje se pro rzn penosov rychlosti:
;     - kontrola vmny mdia (pi vmn se mdium ozna za neznm)
;     - nastaven povelu SPECIFY (protoe se mohou rychlosti mnit)
;     - nastaven penosov rychlosti
;     - vystaven na poadovanou stopu
;     - nastaven kanlu DMA
;     - stanoven parametr operace a vysln povelu
; - pi chyb operace pokus o opakovn s jinmi parametry
; - pi spchu operace stanoven typu disku, mdia a potu penes. sektor
; -----------------------------------------------------------------------------

;
; -----------------------------------------------------------------------------

Funkce02:
Funkce03:
Funkce04:

PUBLIC   RdWrVf
RdWrVf   PROC      NEAR

; ------ kontrola platnosti zadn disku - zda je mechanika nainstalovan

         call      GetStat                  ; poskytnut stavovho bajtu disku
         jnz       RdWrVf0                  ; mechanika je definovan - OK
         mov       ah,80h                   ; chyba - disk nepipraven
         jmp       RdWrVfc                  ; nvrat s chybou

; ------ nastaven pznaku zpisu nebo ten

RdWrVf0: call      ResWr                    ; nastaven pznaku operace ten
         cmp       RegAH,3                  ; je operace zpis ?
         jne       RdWrVf1                  ; nen operace zpis
         call      SetWr                    ; nastaven pznaku operace zpis

; ------ zapnut motoru

RdWrVf1: call      MotorOn

; ------ nastaven poten a koncov rychlosti

         call      GetMed                   ; poskytnut stavovho bajtu mdia
         test      al,10h                   ; je mdium znm ?
         jnz       RdWrVf2                  ; mdium je znm
         call      SetupSt                  ; inic. pot. a kon. rychlosti

; ------ kontrola vmny mdia (zde se zan pi opakovn s jinou rychlost)

RdWrVf2: call      MedChng0                 ; kontrola vmny mdia
         jz        RdWrVf3                  ; mdium nebylo vymnno
         jmp       RdWrVfc                  ; mdium vymnno nebo chyba

; ------ stanoven doby pro krokovn hlav

RdWrVf3: mov       cx,2dfh                  ; standardn rychlost krokovn
         call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,0c0h                  ; je penosov rychlost 500 k/s ?
         jnz       RdWrVf4                  ; nen penosov rychlost 500 K/s
         call      GetTyp                   ; poskytnut typu disku AL
         cmp       al,4                     ; je mechanika 3 1/2" ?
         jne       RdWrVf4                  ; nen mechanika 3 1/2"
         mov       cl,0afh                  ; krokovn pro 1.44 MB v 1.44 MB

; ------ nastaven povelu SPECIFY

RdWrVf4: push      cx                       ; parametry povely SPECIFY
         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,3                     ; povel SPECIFY
         mov       ah,3                     ; poet bajt k vysln
         call      NECOutp                  ; vysln povelu SPECIFY
         pop       cx                       ; zruen dat v zsobnku
         jz        RdWrVf5                  ; operace OK
         jmp       RdWrVfb                  ; chyba - ale je mon opakovat

; ------ nastaven poadovan penosov rychlosti

RdWrVf5: call      SendRate                 ; vysln penosov rychlosti

; ------ test dvojho krokovn

         call      SetDbl                   ; test dvojho krokovn
         or        ah,ah                    ; byla chyba operace ?
         jz        RdWrVf6
         jmp       RdWrVfb

; ------ vystaven na poadovanou stopu

RdWrVf6: mov       al,RegCH                 ; poadovan stopa
         call      Seek                     ; vystaven na poadovanou stopu
         jz        RdWrVf7                  ; operace OK
         jmp       RdWrVfb                  ; chyba operace - ale lze opakovat

; ------ nastaven kanlu DMA

RdWrVf7: mov       al,3                     ; parametr 3 - velikost sektoru
         call      GetPar                   ; poskytnut parametru 3
         mov       cl,al                    ; velikost sektoru
         add       cl,7                     ; korekce na d sektoru
         mov       al,RegAL                 ; poet sektor
         xor       ah,ah                    ; AH <- 0, AX=poet sektor
         shl       ax,cl                    ; vpoet velikosti pamti
         dec       ax                       ; poet bajt - 1
         push      ax                       ; velikost bloku pamti
         push      RegES                    ; ES segment adresy
         push      RegBX                    ; BX offset adresy
         xor       ch,ch                    ; CH <- 0
         mov       cl,RegAH                 ; poadovan funkce
         mov       si,cx                    ; poadovan funkce
         mov       al,ds:[TabFnc+si-2]      ; povel pro funkci
         mov       si,sp                    ; ukazatel dat v zsobnku
         call      SetDma                   ; nastaven kanlu DMA
         add       sp,6                     ; zruen dat v zsobnku
         or        ah,ah                    ; byla chyba operace ?
         jz        RdWrVf8                  ; operace probhla OK
         jmp       short RdWrVfb            ; chyba peteen DMA - lze opakovat

; ------ stanoven dlky penench dat a mezisektorov mezery

RdWrVf8: mov       al,6                     ; parametr 6 - dlka penench dat
         call      GetPar                   ; poskytnut parametru 6 - dlka dat
         mov       ch,al                    ; dlka penench dat (bajt)
         mov       cl,27                    ; mezisektorov mezera pro disky HD
         call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,0c0h                  ; poadovan penosov rychlost
         jz        RdWrVf9                  ; je penosov rychlost HD 500 k/s
         mov       cl,42                    ; mezisektorov mezera pro disky DD
RdWrVf9: push      cx                       ; nastaven parametr do zsobnku

; ------ stanoven maximlnho sektoru a velikosti sektoru

         mov       al,4                     ; parametr 4 - max. sektor
         call      GetPar                   ; poskytnut parametru 4 - max.sekt.
         mov       ch,al                    ; maximln slo sektoru
         mov       al,3                     ; parametr 3 - velikost sektoru
         call      GetPar                   ; poskytnut parametru 3 - vel.sekt.
         mov       cl,al                    ; velikost sektoru
         push      cx                       ; nastaven dat do zsobnku

; ------ nastaven potenho sektoru, vlce a hlavy

         mov       ch,RegCL                 ; poten sektor
         mov       cl,RegDH                 ; poten hlava
         push      cx                       ; nastaven dat do zsobnku
         mov       ch,RegCH                 ; poten stopa
         mov       cl,RegDH                 ; hlava
         and       cl,1                     ; hlava
         shl       cl,1
         shl       cl,1
         or        cl,RegDL                 ; hlava + slo mechaniky
         and       cl,00000101b             ; disk relativn v adii
         push      cx                       ; nastaven dat do zsobnku

; ------ vysln povelu pro proveden operace

         mov       al,0e6h                  ; povel pro ten
         cmp       RegAH,3                  ; je operace zpis ?
         jne       RdWrVfa                  ; nen zpis
         mov       al,0c5h                  ; povel pro zpis
RdWrVfa: mov       ah,9                     ; poet bajt k vysln
         mov       si,sp                    ; ukazatel dat v zsobnku
         call      NECOutp                  ; vysln povelu na adi
         add       sp,8                     ; zruen dat v zsobnku
         or        ah,ah                    ; probhla operace OK ?
         jnz       RdWrVfb                  ; byla chyba operace

; ------ ekn na proveden operace

         call      NECWait                  ; ekn na proveden operace

; ------ nvrat z operace - pi chyb je mon opakovn

RdWrVfb: or        ah,ah                    ; byla njak chyba operace ?
         jz        RdWrVfd                  ; operace probhla OK

; ------ kontrola stavu operace (zda je mon opakovn)

         cmp       ah,80h                   ; byla chyba nepipravenosti ?
         je        RdWrVfc                  ; mechanika nepipravena
         cmp       ah,9                     ; byla chyba DMA ?
         je        RdWrVfc                  ; chyba peteen okraje DMA
         call      GetMed                   ; poskytnut bajtu stavu mdia
         test      al,10h                   ; je mdium ureno ?
         jnz       RdWrVfc                  ; mdium je ureno - je jin chyba

; ------ opakovn operace s jinou penosovou rychlost nebo krokovnm

         call      Retry                    ; nastaven dal penos. rychlosti
         jnz       RdWrVfc                  ; nen mon dal opakovn
         jmp       RdWrVf2                  ; opakovn s jinou penos. rychl.

; ------ chyba operace - nen dn sektor

RdWrVfc: mov       RegAL,0                  ; nastaven AL - nen dn sektor
         ret

; ------ operace probhla OK - schova stavu

RdWrVfd: call      DState                   ; uren typu mdia a mechaniky
         mov       cx,RegCX                 ; slo stopy a sektoru
         mov       dh,RegDH                 ; hlava
         call      NumTrans                 ; uren potu penesench sektor
         mov       RegAL,al                 ; nvrat potu penesench sektor
         xor       ah,ah                    ; pznak operace OK
RdWrVfe: ret

RdWrVf   ENDP

TabFnc   db        46h,4ah,42h              ; povely pro funkce 2,3,4

; -----------------------------------------------------------------------------
;        Funkce 5 - formtovn stopy
; -----------------------------------------------------------------------------

PUBLIC   Funkce05
Funkce05 PROC      NEAR

; ------ kontrola, zda je disk instalovn

         call      GetStat                  ; poskytnut stavovho bajtu disku
         jnz       Format1                  ; mechanika je instalovna
         mov       ah,80h                   ; chyba - disk nepipraven
         jmp       Format7                  ; chybov nvrat

; ------ uren typu mdia

Format1: call      GetMed                   ; poskytnut bajtu stavu mdia
         test      al,10h                   ; je mdium ureno ?
         jnz       Format2                  ; mdium je ureno
         call      MedDet                   ; implicitn uren typu mdia

; ------ kontrola vmny mdia

Format2: call      SetWr                    ; pznak operace zpis
         call      MedChng                  ; kontrola vmny mdia
         jz        Format3                  ; mdium nebylo vymnno
         jmp       Format7                  ; mdium vymnno nebo chyba

; ------ vysln povelu SPECIFY na adi

Format3: mov       al,1                     ; parametr 1 - sputn hlavy
         call      GetPar                   ; poskytnut parametru 1
         mov       ah,al                    ; parametr 1
         xor       al,al                    ; parametr 0 - krokovn
         call      GetPar                   ; poskytnut parametru 0
         push      ax                       ; krokovn a doba zputn ptlaku
         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,3                     ; povel SPECIFY
         mov       ah,3                     ; poet bajt k vysln
         call      NECOutp                  ; vysln povelu SPECIFY na adi
         pop       cx                       ; zruen parametr ze zsobnku
         jz        Format4                  ; operace probhla OK
         jmp       short Format7            ; chyba pi vysln povelu na adi

; ------ nastaven penosov rychlosti

Format4: call      SendRate                 ; vysln penosov rychlosti

; ------ nastaven kanlu DMA

         mov       al,4                     ; parametr 4 - poet sekt. na stopu
         call      GetPar                   ; poskytnut parametru 4
         shl       ax,1
         shl       ax,1                     ; vynsoben 4 bajty na sektor
         dec       ax                       ; poet bajt - 1
         push      ax                       ; poet bajt k vysln na adi
         push      RegES                    ; segment adresy tabulky (ES)
         push      RegBX                    ; offset adresy tabulky (BX)
         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,4ah                   ; povel pro nastaven adie DMA
         call      SetDMA                   ; nastaven kanlu DMA
         add       sp,6                     ; zruen dat v zsobnku
         or        ah,ah                    ; probhlo nastaven DMA OK ?
         jz        Format5                  ; kanl DMA byl nastaven OK
         jmp       RdWrVfe                  ; nvrat pi chyb

; ------ vystaven hlav na poadovanou stopu

Format5: mov       al,RegCH                 ; stopa
         call      Seek                     ; vystaven na poadovanou stopu
         jz        Format6                  ; vystaven probhlo OK
         jmp       short Format7            ; nvrat pi chyb

; ------ vysln povelu pro formtovn

Format6: mov       al,8                     ; parametr 8 - datov vzor
         call      GetPar                   ; poskytnut parametru 8
         push      ax                       ; plnic znak pro formtovn

         mov       al,7                     ; parametr 7 - mezisekt. mezera
         call      GetPar                   ; poskytnut parametru 7
         mov       ah,al                    ; parametr 7

         mov       al,4                     ; parametr 4 - posledn sektor
         call      GetPar                   ; poskytnut parametru 4
         push      ax                       ; nastaven mezery a max. sektoru

         mov       al,3                     ; parametr 3 - velikost sektoru
         call      GetPar                   ; poskytnut parametru 3
         mov       ah,al                    ; parametr 3
         mov       al,RegDH                 ; poadovan hlava
         and       al,1
         shl       al,1
         shl       al,1                     ; rotace na pozici
         or        al,bl                    ; poadovan disk
         and       al,00000101b             ; disk relativn
         push      ax                       ; disk a sektor do zsobnku

         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,4dh                   ; povel pro formtovn
         mov       ah,6                     ; poet bajt k vysln
         call      NECOutp                  ; vysln povelu na adi
         add       sp,6                     ; zruen dat v zsobnku
         or        ah,ah                    ; byla chyba operace ?
         jnz       Format7                  ; chyba vysln povelu na adi

; ------ ekn na proveden operace

         call      NECWait                  ; ekn na proveden operace
Format7: ret

Funkce05 ENDP

; -----------------------------------------------------------------------------
;        Funkce 8 - poskytnut aktulnch diskovch parametr
; -----------------------------------------------------------------------------

PUBLIC   Funkce08
Funkce08 PROC      NEAR

; ------ test, zda je njak disk

         mov       al,es:[410h]             ; bajt vybaven
         test      al,1                     ; je njak disk ?
         jnz       DiskPar1                 ; je njak disk
         xor       al,al                    ; nen dn disk
         jmp       short DiskPar2           ; nen dn disk

; ------ stanoven potu disk

DiskPar1:rol       al,1
         rol       al,1                     ; AL <- poet disk
         and       al,3                     ; poet disk - 1
         inc       al                       ; poet disk

; ------ kontrola, zda je zadn platn disk

DiskPar2:xchg      al,RegDL                 ; poet disk
         cmp       al,80h                   ; je zadn pevn disk ?
         jb        DiskPar3                 ; je disketa - OK
         mov       ah,1                     ; chyba - neplatn funkce
         mov       RegDL,0                  ; poet disk = 0
         jmp       DiskPar9

; ------ oven potu mechanik

DiskPar3:cmp       RegDL,0                  ; je njak mechanika ?
         je        DiskPar5                 ; nen dn mechanika
         cmp       al,3                     ; je zadn disk 0 a 3 ?
         ja        DiskPar5                 ; chybn slo disku

; ------ nastaven typu mechaniky z CMOS

         call      GetTyp                   ; poskytnut typu disku AL
         jz        DiskPar4                 ; nen to platn mechanika
         mov       cl,al                    ; typ mechaniky
         xor       ch,ch                    ; CH <- 0
         mov       RegBX,cx                 ; nastaven typu mechaniky
         jmp       short DiskPar6

; ------ neplatn mechanika v CMOS - pokus o uren

DiskPar4:call      GetMed                   ; poskytnut bajtu stavu mdia
         test      al,10h                   ; je mdium ureno ?
         jz        DiskPar5                 ; mdium nen ureno
         xor       cx,cx                    ; CX <- 0
         mov       RegBX,cx                 ; registr BX <- 0
         mov       cl,al                    ; stavov bajt mdia
         rol       cl,1
         rol       cl,1
         rol       cl,1                     ; CL <- penosov rychlost
         and       cl,6                     ; penosov rychlost * 2
         call      GetStat                  ; poskytnut stavovho bajtu disku
         and       al,1                     ; pznak mechaniky 80 stop
         or        cl,al                    ; nastaven pznaku 80 stop
         mov       si,cx                    ; pznaky mechaniky
         mov       al,ds:[TabDiskP+si]      ; typ disku
         jmp       short DiskPar6

; ------ mdium nen ureno

DiskPar5:mov       RegAX,0
         mov       RegBX,0
         mov       RegCX,0
         mov       RegDH,0
         mov       RegES,0
         mov       RegDI,0
         jmp       short DiskPar8

; ------ zjitn parametr diskety (AL=typ mechaniky 1 a 4)

DiskPar6:call      GetTab                   ; poskytnut adresy tabulky disku
         test      al,1                     ; je disk DD ?
         jnz       DiskPar7                 ; je disk DD
         add       si,13                    ; je disk HD - je i disketa HD

; ------ nastaven parametr k nvratu

DiskPar7:mov       RegAX,0
         mov       al,ds:[si+4]             ; posledn sektor na stop
         mov       ah,ds:[si+11]            ; posledn stopa
         mov       RegCX,ax                 ; reg. CX <- posledn sektor a stopa
         mov       RegDH,1                  ; DH <- slo posledn hlavy
         mov       RegDI,si                 ; DI <- offset tabulky parametr
         mov       RegES,cs                 ; ES <- segment tabulky parametr
DiskPar8:xor       ah,ah                    ; nvratov kd (=OK)
DiskPar9:ret

Funkce08 ENDP

TabDiskP db        4                        ; 40 stop, 500 k/s (1.44 MB)
         db        4                        ; 80 stop, 500 k/s (1.44 MB)
         db        2                        ; 40 stop, 300 k/s (1.2 MB)
         db        2                        ; 80 stop, 300 k/s (1.2 MB)
         db        1                        ; 40 stop, 250 k/s (360 KB)
         db        4                        ; 80 stop, 250 k/s (1.44 MB)
         db        4                        ; 40 stop, xxx k/s (1.44 MB)
         db        4                        ; 80 stop, xxx k/s (1.44 MB)

; -----------------------------------------------------------------------------
;        Funkce 0ah - vyhledvn sektor
; -----------------------------------------------------------------------------

PUBLIC   Funkce0a
Funkce0a PROC      NEAR

; ------ kontrola platnosti zadn disku - zda je mechanika nainstalovan

         mov       ah,80h                   ; chyba - disk nepipraven
         call      GetStat                  ; poskytnut stavovho bajtu disku
         jnz       Fnc0a0                   ; mechanika definovan OK
Fnc0af2: jmp       Fnc0af                   ; chyba - mechanika nen definovan

; ------ test, zda je mdium znm

Fnc0a0:  mov       ah,0ch                   ; chyba - typ mdia neznm
         call      GetMed                   ; poskytnut stavovho bajtu mdia
         test      al,10h                   ; je mdium znm ?
         jz        Fnc0af2                  ; chyba - mdium neznm

; ------ kontrola vmny mdia

         call      MedChng                  ; kontrola vmny mdia
         jnz       Fnc0af2                  ; mdium vymnno nebo chyba

; ------ nastaven poadovan penosov rychlosti

         call      SendRate                 ; vysln penosov rychlosti

; ------ vystaven na poadovanou stopu

         mov       al,RegCH                 ; poadovan stopa
         call      Seek                     ; vystaven na poadovanou stopu
         jnz       Fnc0af2                  ; chyba operace

; ------ doba pro vypnut motoru na maximum

         mov       al,0ffh                  ; inicializan doba pro vypnut
         call      SetMOff                  ; nastaven doby pro vypnut

; ------ synchonizace na hranu hodin

         mov       byte ptr ds:[Counter2],1 ; hodnota pro synchronizaci hodin
Fnc0a8:  cmp       byte ptr ds:[Counter2],0 ; byla hrana hodin ?
         jne       Fnc0a8                   ; ekn na hranu hodin
         mov       byte ptr ds:[Counter2],4 ; doba pro asi jednu otku
         mov       di,RegBX                 ; offset ukldac adresy
         mov       RegAL,0                  ; poet nalezench identif. = 0

; ------ nalezen identifiktoru

Fnc0a9:  mov       dl,RegDH                 ; hlava
         and       dl,1                     ; hlava
         shl       dl,1
         shl       dl,1
         or        dl,bl                    ; hlava + slo mechaniky
         and       dl,00000101b             ; disk relativn v adii
         push      dx                       ; poadovan disk
         mov       si,sp                    ; ukazatel parametr
         mov       al,4ah                   ; povel pro ten identifiktoru ID
         mov       ah,2                     ; poet parametr READ ID
         call      NECOutp                  ; vysln povelu READ ID na adi
         pop       dx                       ; zruen dat v zsobnku
         jnz       Fnc0af2                  ; byla chyba operace

; ------ test, zda byl ID nalezen

         call      NECWait                  ; ekn na proveden operace
         jnz       Fnc0ah                   ; ID nenalezen - to je OK

; ------ test, zda byl identifiktor ji nalezen

         cmp       byte ptr ds:[Counter2],1 ; petekl ji asova ?
         ja        Fnc0ai                   ; asova jet nepetekl

         mov       ah,3                     ; poten poloka - stopa
         mov       si,RegBX                 ; offset bufferu
Fnc0aj:  mov       al,ah                    ; slo poloky
         call      GetRes                   ; poskytnut poloky
         push      es
         mov       es,RegES                 ; segment bufferu
         cmp       es:[si],al               ; je poloka stejn ?
         pop       es
         jne       Fnc0ai                   ; poloka je jin
         inc       ah                       ; zven sla poloky
         inc       si                       ; zven adresy v bufferu
         cmp       ah,6                     ; byla ji posledn poloka ?
         jbe       Fnc0aj                   ; schova dal poloky
         jmp       short Fnc0ah             ; poloka byla ji nalezena

; ------ operace probhla OK - schova identifiktoru

Fnc0ai:  inc       RegAL                    ; zven tae nalezench ident.
         mov       ah,3                     ; poten poloka - stopa
Fnc0ae:  mov       al,ah
         call      GetRes                   ; poskytnut poloky
         push      es
         mov       es,RegES                 ; segment bufferu
         mov       es:[di],al               ; uloen parametru do bufferu
         inc       di                       ; zven ukldac adresy
         pop       es
         inc       ah                       ; zven sla poloky
         cmp       ah,6                     ; byla ji posledn poloka ?
         jbe       Fnc0ae                   ; schova dal poloky

; ------ test, zda se m pokraovat v hledn

         cmp       byte ptr ds:[Counter2],0 ; uplynul ji zadan as ?
         jne       Fnc0a9                   ; as jet neuplynul

; ------ setdn tabulky v bufferu

Fnc0ah:  xor       cx,cx
         mov       cl,RegAL                 ; poet nalezench sektor
         jcxz      Fnc0ak                   ; nebyl dn sektor

; ------ nalezen nejmenho sektoru

         push      es
         push      cx
         mov       es,RegES                 ; segment s bufferem
         mov       si,RegBX                 ; offset bufferu
         mov       dh,0ffh                  ; slo nejmenho sektoru
Fnc0al:  cmp       dh,es:[si+2]             ; je sektor men ?
         jbe       Fnc0am                   ; sektor nen men
         mov       dh,es:[si+2]             ; nov nejmen sektor
Fnc0am:  add       si,4                     ; zven adresy v bufferu
         loop      Fnc0al                   ; test dalho sektoru
         pop       cx
         pop       es

; ------ test, zda je prvn sektor nejni

Fnc0an:  push      es
         mov       es,RegES                 ; segment s bufferem
         mov       si,RegBX                 ; offset bufferu
         cmp       dh,es:[si+2]             ; je prvn sektor nejni ?
         pop       es
         je        Fnc0ak                   ; sektor je nejni

; ------ rotace sektor o jeden sektor dol

         push      es
         push      cx
         push      dx

         dec       cx                       ; snen o 1
         add       cx,cx
         add       cx,cx                    ; poet poloek * 4

         mov       es,RegES                 ; segment s bufferem
         mov       si,RegBX                 ; offset bufferu

         mov       dx,es:[si]               ; schova prvn poloky
         mov       di,es:[si+2]

Fnc0ao:  mov       al,es:[si+4]
         mov       es:[si],al
         inc       si
         loop      Fnc0ao

         mov       es:[si],dx
         mov       es:[si+2],di

         pop       dx
         pop       cx
         pop       es
         jmp       short Fnc0an             ; test novho stavu

Fnc0ak:  xor       ah,ah                    ; pznak - operace OK
Fnc0af:  ret

Funkce0a ENDP

; -----------------------------------------------------------------------------
;        Funkce 0ch - vystaven na vlec
; -----------------------------------------------------------------------------

PUBLIC   Funkce0c
Funkce0c PROC      NEAR

         mov       RegAL,0                  ; pednastaven - nen stopa 0

; ------ kontrola platnosti zadn disku - zda je mechanika nainstalovan

         call      GetStat                  ; poskytnut stavovho bajtu disku
         mov       ax,8000h                 ; chyba - disk nepipraven
         jz        Fnc0c2                   ; mechanika nen definovan - chyba

; ------ test, zda je pouze dotaz na aktuln stopu

         xor       ah,ah                    ; nvratov kd - OK
         cmp       RegCH,0ffh               ; je jenom dotaz na stopu ?
         je        Fnc0c1                   ; nen jenom dotaz na stopu

; ------ zapnut motoru

         call      MotorOn

; ------ vystaven na poadovan vlec

         mov       al,RegCH                 ; poadovan vlec
         call      Seek                     ; vystaven na poadovan vlec
         jnz       Fnc0c1                   ; byla chyba vystaven

; ------ test, zda je dosaeno stopy 0

         call      DrivStat                 ; poskytnut stavovho bajtu disku
         jnz       Fnc0c1                   ; chyba operace
         test      al,10h                   ; bylo dosaeno stopy 0 ?
         jz        Fnc0c1                   ; stopa 0 nenalezena - dal
         mov       RegAL,0ffh               ; pznak dosaen stopy 0

; ------ poskytnut aktulnho vlce

Fnc0c1:  call      GetSeek                  ; poskytnut aktulnho vlce
Fnc0c2:  mov       RegCH,al                 ; navrcen aktulnho vlce
         ret

Funkce0c ENDP

; -----------------------------------------------------------------------------
;        Funkce 10h - test pipravenosti disku
; -----------------------------------------------------------------------------

PUBLIC   Funkce10
Funkce10 PROC      NEAR

         mov       RegAL,11011000b          ; pednastaven stavu

; ------ kontrola platnosti zadn disku - zda je mechanika nainstalovan

         call      GetStat                  ; poskytnut stavovho bajtu disku
         mov       ah,80h                   ; chyba - disk nepipraven
         jz        Fnc101                   ; mechanika nen definovan - chyba

; ------ zapnut motoru

         call      MotorOn

; ------ test pipravenosti disku

         call      DrivStat                 ; poskytnut stavovho bajtu disku
         jnz       Fnc101                   ; disk nen pipraven
         mov       cl,al                    ; schova stavovho bajtu
         and       cl,not 8                 ; nulovn bitu 3
         call      ReadChng                 ; ten signlu vmny
         jz        Fnc102                   ; signl vmny nen aktivn
         or        cl,8                     ; nastaven pznaku vmny
Fnc102:  mov       RegAL,cl                 ; stavov bajt diskov jednotky
         test      cl,20h                   ; je disketov jednotka pipravena ?
         jnz       Fnc101                   ; disketov jednotka je pipravena
         mov       ah,80h                   ; pznak nepipravenosti disku

Fnc101:  ret

Funkce10 ENDP

; -----------------------------------------------------------------------------
;        Funkce 15h - poskytnut typu disku
; -----------------------------------------------------------------------------

PUBLIC   Funkce15
Funkce15 PROC      NEAR

         call      GetStat                  ; poskytnut stavovho bajtu disku
         jz        Fnc151                   ; disk nen definovn
         and       al,1                     ; pznak 80 stop
         inc       al                       ; pznak indikace vmny + 1
Fnc151:  mov       ah,al
         ret

Funkce15 ENDP

; -----------------------------------------------------------------------------
;        Funkce 16h - test vmny mdia
; -----------------------------------------------------------------------------

PUBLIC   Funkce16
Funkce16 PROC      NEAR

; ------ zjitn, zda je disk definovn

         mov       ah,80h                   ; pednastaven chyby - nen disk
         call      GetStat                  ; poskytnut stavovho bajtu disku
         jz        Fnc161                   ; disk nen definovn

; ------ test, zda m disk indikaci vmny mdia

         mov       ah,6                     ; pednastaven chyby - je vmna
         test      al,1                     ; je indikace vmny mdia ?
         jz        Fnc161                   ; disk nem indikaci vmny mdia

; ------ zapnut motoru a test, zda bylo mdium vymnno

         call      MotorOn                  ; zapnut motoru
         call      ReadChng                 ; ten signlu vmny mdia
         mov       ah,6
         jnz       Fnc161                   ; mdium bylo vymnno
         xor       ah,ah                    ; pznak, e mdium nebylo vymnno
Fnc161:  ret

Funkce16 ENDP

; -----------------------------------------------------------------------------
;        Funkce 17h - nastaven typu disku pro formtovn
; -----------------------------------------------------------------------------

PUBLIC   Funkce17
Funkce17 PROC      NEAR

; ------ ppad, e je disk 360 KB v mechanice 360 KB

         cmp       RegAL,1                  ; zadn disk 360K v mechanice 360K ?
         jne       Fnc171                   ; nen disk 360K v mechanice 360K
         xor       ah,ah                    ; pznak operace OK
         mov       cl,90h                   ; rychlost 250 k/s
         jmp       short Fnc176             ; nastaven rychlosti

; ------ test vmny mdia

Fnc171:  call      MedChng                  ; obsluha vmny mdia
         jz        Fnc172                   ; mdium nebylo vymnno
         xor       cl,cl                    ; rychlost 500 k/s
         jmp       short Fnc176             ; nastaven rychlosti

; ------ kontrola zadn typu DASD

Fnc172:  xor       dx,dx                    ; DX <- 0
         or        dl,RegAL                 ; poadovan typ DASD
         jz        Fnc173                   ; chybn zadn typu (=0)
         cmp       dl,4                     ; kontrola maximln velikosti DASD
         jbe       Fnc174                   ; sprvn typ DASD

; ------ chybn zadn typu DASD

Fnc173:  mov       ah,1                     ; chyba - neplatn povel
         xor       cl,cl                    ; rychlost 500 k/s
         jmp       short Fnc176             ; nastaven rychlosti

; ------ zadn typ 720K (rozlien mechaniky 5 1/4" nebo 3 1/2")

Fnc174:  jne       Fnc175                   ; nen zadn typ 720K v 720K
         call      GetTyp                   ; poskytnut typu mechaniky
         cmp       al,2                     ; je mechanika 1.2 MB ?
         jne       Fnc175                   ; nen mechanika 1.2 MB
;         call      GetStat                  ; poskytnut stavovho bajtu disku
;         and       al,6                     ; pznak vce rychlost
;         cmp       al,6                     ; je mon vce rychlost ?
;         jne       Fnc175                   ; nen mon vce rychlost
         inc       dl                       ; je typ 5 - mechanika 5 1/4" HD

; ------ zjitn penos. rychlosti z tabulky

Fnc175:  mov       di,dx                    ; typ disku
         and       di,7                     ; typ disku
         mov       cl,ds:[TabDASD+di]       ; typ z tabulky DASD

; ------ nastaven penosov rychlosti

Fnc176:  call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,0fh                   ; nulovn rychlosti a pznak typu
         or        al,cl                    ; nastaven rychlosti a typu
         call      SetMed                   ; nastaven bajtu stavu mdia
         ret

Funkce17 ENDP

TabDASD  db        0                        ; (0 - nepovolen typ)
         db        0                        ; (1 - 360K/360K (90h); 250k/s)
         db        70h                      ; 2 - 360K/1.2M; 300k/s (2-krok.)
         db        10h                      ; 3 - 1.2M/1.2M, 1.44M/1.44M; 500k/s
         db        90h                      ; 4 - 720K/720K, 720K/1.44M; 250k/s
         db        50h                      ; 5 - 720K/1.2M; 300k/s

; -----------------------------------------------------------------------------
;        Funkce 18h - nastaven typu mdia pro formtovn
; -----------------------------------------------------------------------------

PUBLIC   Funkce18
Funkce18 PROC      NEAR

; ------ kontrola, zda je disk definovn

         call      GetStat                  ; poskytnut stavovho bajtu disku
         jz        Fnc186                   ; disk nen instalovn

; ------ kontrola, zda mdium nebylo vymnno

         test      al,1                     ; je mechanika 80 stop ?
         jz        Fnc181                   ; je mechanika 40 stop
         call      MedChng                  ; obsluha vmny mdia
         jz        Fnc181                   ; disketa nebyla vymnna
         cmp       ah,6                     ; mdium bylo vymnno ?
         je        Fnc181                   ; mdium vymnno - OK
         jmp       short Fnc187             ; chyba, pokud disketa byla vymnna

; ------ zjitn tabulky podle typu

Fnc181:  call      GetTyp                   ; poskytnut typu disku AL
         jz        Fnc186                   ; nen dn disk
         cmp       al,2                     ; je mechanika 1.2 MB ?
         jne       Fnc182                   ; nen mechanika 1.2 MB
         cmp       RegCX,4f09h              ; poaduje se 720 KB ?
         mov       si,offset Disk7          ; tabulka pro 720 KB v 1.2 MB
         je        Fnc184                   ; je 720 KB v 1.2 MB
Fnc182:  call      GetTab                   ; uren tabulky disku podle typu

; ------ kontrola, zda byla nalezena platn tabulka

Fnc183:  mov       cl,ds:[si+4]             ; posledn sektor na stop
         mov       ch,ds:[si+11]            ; posledn stopa
         cmp       cx,RegCX                 ; kontrola zadanch parametr
         je        Fnc184                   ; nalezena platn tabulka parametr

; ------ nen platn tabulka - ppadn druh pokus

         test      al,1                     ; je ji prvn typ disku
         jnz       Fnc188                   ; nen povolen dal formt
         dec       al                       ; dal povolen formt
         add       si,0dh                   ; dal tabulka
         jmp       short Fnc183             ; test dal tabulky

; ------ nastaven parametr podle tabulky

Fnc184:  mov       al,ds:[si+12]            ; penosov rychlost
         cmp       al,40h                   ; rychlost 300 K/s ?
         jne       Fnc185                   ; nen rychlost 300 k/s
         cmp       si,offset Disk7          ; je 720 KB v 1.2 MB ?
         je        Fnc185                   ; je 720 KB v 1.2 MB
         or        al,20h                   ; pznak dvojho krokovn
Fnc185:  or        al,10h                   ; pznak uren mdia
         call      SetMed                   ; nastaven bajtu stavu mdia

; ------ nastaven ukazatele na tabulku

         mov       RegDI,si
         mov       RegES,cs

Fnc186:  xor       ax,ax
Fnc187:  ret

; ------ chyba - typ mdia nenalezen

Fnc188:  mov       ah,0ch
         ret

Funkce18 ENDP

; -----------------------------------------------------------------------------
;        Konverze novho mdu na star
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   XlatOld
XlatOld  PROC      NEAR

         push      ax
         push      cx
         push      si
         mov       ch,7                     ; stav - jin typ mdia

; ------ pednastaven pznaku 80 stop

         call      GetStat                  ; poskytnut bajtu stavu disku
         and       al,1                     ; pznak mechaniky 80 stop
         mov       cl,al                    ; pznak mechaniky 80 stop

; ------ rozlien podle penosov rychlosti

         call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,0c0h                  ; penosov rychlost
         jz        XlatOld2                 ; je disketa HD (rychlost 500 k/s)
         cmp       al,80h                   ; je rychlost 250 k/s ?
         ja        XlatOld3                 ; chyba - neznm disk
         je        XlatOld1                 ; je rychlost 250 k/s
         or        cl,8                     ; pznak rychlosti 300 k/s

; ------ konverze typu podle detekovanch pznak

XlatOld1:call      GetMed                   ; poskytnut bajtu stavu mdia
         shr       al,1
         shr       al,1
         shr       al,1
         and       al,6                     ; pznak dvoj. krok. a znm mdium
         or        cl,al
         mov       si,cx                    ; pznaky
         and       si,0fh                   ; maska pznak
         mov       ch,ds:[TabXlat+si]       ; konverze
         jmp       short XlatOld3           ; nastaven novho typu mdia

; ------ penosov rychlost 500 k/s - je disketa HD

XlatOld2:call      GetTyp                   ; poskytnut typu disku AL
         cmp       al,2                     ; mechanika 1.2 MB ?
         jne       XlatOld3                 ; nen 1.2 MB
         mov       ch,2                     ; disketa 1.2 MB v 1.2 MB nezaved.
         call      GetMed                   ; poskytnut bajtu stavu mdia
         test      al,10h                   ; je mdium znm ?
         jz        XlatOld3                 ; mdium nen znm
         mov       ch,5                     ; disketa 1.2 MB v 1.2 MB zaved.

; ------ nastaven novho typu mdia

XlatOld3:call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,0f8h                  ; zruen starho typu mdia
         or        al,ch                    ; nastaven typu mdia
         call      SetMed                   ; nastaven stavovho bajtu mdia
         pop       si
         pop       cx
         pop       ax
         ret

XlatOld  ENDP


TabXlat  label     byte                   ;* mechaniky 300 ot/min

                                          ;* 360K v 360K nezaveden
         db        0                        ; 0 40 stop; mdium neznm; 1 krok
         db        7                        ; 1 80 stop; mdium neznm; 1 krok

                                          ;* 360K v 360K zaveden
         db        3                        ; 2 40 stop; mdium znm; 1 krok
         db        7                        ; 3 80 stop; mdium znm; 1 krok

                                          ;* 360K v 360K nezaveden, 2-kroky
         db        0                        ; 4 40 stop; mdium neznm; 2 kroky
         db        7                        ; 5 80 stop; mdium neznm; 2 kroky

                                          ;* 360K v 360K nezaveden, 2-kroky
         db        3                        ; 6 40 stop; mdium znm; 2 kroky
         db        7                        ; 7 80 stop; mdium znm; 2 kroky

                                          ;* mechaniky 360 ot/min
         db        7                        ; 8  40 stop; mdium neznm; 1 krok
         db        7                        ; 9  80 stop; mdium neznm; 1 krok
         db        7                        ; 10 40 stop; mdium znm; 1 krok
         db        7                        ; 11 80 stop; mdium znm; 1 krok

                                          ;* 360K v 1.2M nezaveden
         db        1                        ; 12 40 stop; md. neznm; 2 kroky

                                          ;* 360K v 1.2M nezaveden
         db        1                        ; 13 80 stop; md. neznm; 2 kroky

         db        4                        ; 14 40 stop; mdium znm; 2 kroky
         db        4                        ; 15 80 stop; mdium znm; 2 kroky


; -----------------------------------------------------------------------------
;        Uren potu penesench sektor
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        CL=poten sektor
;        CH=poten vlec
;        DH=poten strana
;        ES=0
;        DS=CS
; VSTUP:AL=poet penesench sektor
; Znien registry: AH
; -----------------------------------------------------------------------------

PUBLIC   NumTrans
NumTrans PROC      NEAR

; ------ posledn penesen sektor

         mov       al,5                     ; parametr 5 - posledn sektor
         call      GetRes                   ; poskytnut poslednho sektoru
         mov       ah,al                    ; posledn penesen sektor

; ------ test, zda byla zmnna strana

         mov       al,4                     ; parametr 4 - posledn strana
         call      GetRes                   ; poskytnut posledn strany
         cmp       al,dh                    ; byla zmnna strana ?
         jne       NumTrns1                 ; byla zmnna strana

; ------ test, zda byla zmnna stopa

         mov       al,3                     ; parametr 3 - posledn stopa
         call      GetRes                   ; poskytnut posledn stopy
         cmp       al,ch                    ; byla zmnna stopa ?
         je        NumTrns2                 ; ani stopa nebyla zmnna

; ------ piten sektor z cel stopy (2x), pokud byla zmnna stopa

         mov       al,4                     ; param. 4 - poet sektor na stopu
         call      GetPar                   ; poskytnut parametru 4
         add       ah,al                    ; piten sektor pro dal stopu

; ------ piten sektor z cel stopy, pokud byla zmnna strana

NumTrns1:mov       al,4                     ; param. 4 - poet sektor na stopu
         call      GetPar                   ; poskytnut parametru 4
         add       ah,al                    ; piten sektor pro dal stranu

; ------ odeten potenho sektoru

NumTrns2:sub       ah,cl                    ; odeten potenho sektoru
         mov       al,ah                    ; poet penesench sektor
         ret

NumTrans ENDP

; -----------------------------------------------------------------------------
;        Nastaven kanlu DMA (pouv se kanl slo 2)
; -----------------------------------------------------------------------------
; VSTUP: (BL=slo disku)
;        AL=povel pro DMA (46h=ten, 4ah=zpis, 42h=verifikace)
;        SS:SI=ukazatel parametr v zsobnku (adresa DMA a poet bajt)
;        ES=0
;        DS=CS
; VSTUP:AH=nvratov chybov kd (9=chyba pekroen hranice 64K)
;        ZY=operace OK (AH=0), NZ=chyba operace (AH=9)
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   SetDma
SetDma   PROC      NEAR

         push      cx

; ------ nastaven povelu pro DMA

         cli                                ; zkaz peruen
         out       [0ch],al                 ; nastaven pznaku nslednosti DMA
         jmp       short $+2                ; prodleva
         out       [0bh],al                 ; nastaven povelu pro DMA

; ------ vpoet adresy pro penos DMA

         mov       ax,ss:[si+2]             ; segment adresy
         mov       ch,ah                    ; vy bajt segmentu adresy
         mov       cl,4                     ; poet rotac
         shl       ax,cl                    ; segment * 16 -> offset
         shr       ch,cl                    ; vy 4 bity segmentu
         xor       cl,cl                    ; CL <- 0
         xchg      cl,ch                    ; CX = nejvy bajt adresy
         add       ax,ss:[si]               ; piten offsetu adresy
         adc       cl,ch                    ; penos do vych 4 bit adresy

; ------ nastaven adresy pro penos DMA (kanl 2)

         out       [4],al                   ; vysln niho bajtu adresy
         xchg      al,ah                    ; AL <- vy bajt adresy
         jmp       short $+2                ; prodleva
         out       [4],al                   ; vysln vyho bajtu adresy
         jmp       short $+2                ; prodleva
         xchg      al,ah                    ; nvrat adresy
         xchg      ax,cx                    ; AX<-vy bajt, CX<-ni slovo
         out       [81h],al                 ; nastaven strnkovho registru
         jmp       short $+2                ; prodleva

; ------ nastaven potu bajt k penosu

         mov       ax,ss:[si+4]             ; poet bajt k penosu
         out       [5],al                   ; ni slovo potu bajt
         mov       al,ah                    ; vy slovo potu bajt
         jmp       short $+2                ; prodleva
         out       [5],al                   ; vy slovo potu bajt

; ------ volba kanlu pro penos DMA

         mov       al,2                     ; kanl 2
         out       [0ah],al                 ; volba kanlu DMA 2
         sti                                ; povolen peruen

; ------ kontrola pekroen hranice 64K

         mov       ah,9                     ; chyba pekroen hranice 64K
         add       cx,ss:[si+4]             ; kontrola pekroen hranice 64K
         jc        SetDMA1                  ; bylo pekroen hranice 64K
         xor       ah,ah                    ; pznak operace OK

SetDMA1: or        ah,ah                    ; nastaven pznaky chyby ZF
         pop       cx
         ret

SetDma   ENDP

; *****************************************************************************
;        Vystavovn hlav
; *****************************************************************************

; -----------------------------------------------------------------------------
;        Resetovn diskovho systmu
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AH=nvratov chybov kd
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; Znien registry: AL, CX, DX, SI
; -----------------------------------------------------------------------------

PUBLIC   DiskRes
DiskRes  PROC      NEAR

; ------ nulovn pznak proveden rekalibrace

         xor       al,al                    ; nulovn pznak rekalibrace
         call      SetRec                   ; nastaven bajtu pznak rekalib.

; ------ vysln signlu RESET

         cli                                ; zkaz peruen
         call      GetMot                   ; poskytnut bajtu stavu motor
         rol       al,1
         rol       al,1
         rol       al,1
         rol       al,1                     ; rotace na sprvnou pozici
         and       al,not 4                 ; nastaven signlu RESET
         or        al,8                     ; povolen peruen a DMA
         call      GetPrt2                  ; adresa dicho portu adie
         out       dx,al                    ; vysln signlu RESET

; ------ prodleva pro pjem povelu RESET adie

         jmp       short $+2
         jmp       short $+2
         jmp       short $+2
         jmp       short $+2                ; prodleva pro povel RESET

; ------ ukonen signlu RESET

         or        al,4                     ; vypnut signlu RESET
         out       dx,al                    ; ukonen signlu RESET
         sti                                ; povolen peruen

; ------ kontrola vsledku operace

         call      ChkStat                  ; kontrola vsledku operace resetu
         xor       al,al                    ; parametr 0 - registr ST0
         call      GetRes                   ; poskytnut parametru 0 - ST0
         mov       ah,20h                   ; kd chyby - chyba adie
         cmp       al,0c0h                  ; sprvn vsledek operace (ST0) ?
         jne       DiskRes2                 ; chyba resetovn adie

; ------ vysln povelu SPECIFY

         mov       al,1                     ; parametr 1 - sputn ptlaku
         call      GetPar                   ; poskytnut parametru 1
         mov       ah,al                    ; parametr 1 - sputn ptlaku
         xor       al,al                    ; parametr 0 - rychlost krokovn
         call      GetPar                   ; poskytnut parametru 0
         push      ax                       ; parametry pro povel SPECIFY
         mov       si,sp                    ; ukazatel prametr v zsobnku
         mov       al,3                     ; povel 3 - SPECIFY
         mov       ah,3                     ; celkov poet bajt = 3
         call      NECOutp                  ; vysln parametr na adi
         add       sp,2                     ; zruen dat v zsobnku

DiskRes2:or        ah,ah                    ; nastaven pznaku ZF
         ret

DiskRes  ENDP

; -----------------------------------------------------------------------------
;        Vystaven mechaniky BL na stopu AL
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=poadovan stopa
;        ES=0
;        DS=CS
; VSTUP:AH=nvratov chybov kd
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; Znien registry: AL, SI
; -----------------------------------------------------------------------------

PUBLIC   Seek
Seek     PROC      NEAR

         push      dx
         mov       dh,al                    ; poadovan stopa

; ------ test, zda se vyaduje rekalibrace

         mov       ah,bl                    ; disk
         and       ah,1                     ; disk 0 nebo 1
         mov       dl,ah                    ; schova sla disku
         inc       ah                       ; maska rekalibrace (1 nebo 2)
         call      GetRec                   ; poskytnut bajtu rekalibrace
         test      al,ah                    ; vyaduje se rekalibrace ?
         jnz       Seek2                    ; rekalibrace se nevyaduje

; ------ provede se rekalibrace disku

         or        al,ah                    ; nastaven pznaku rekalibrace
         call      SetRec                   ; nastaven bajtu rekalibrace
         xor       al,al                    ; nov stopa = 0
         call      SetSeek                  ; nastaven nov stopy
         mov       cx,2                     ; poet pokus = 2

; ------ vysln povelu pro rekalibraci disku

Seek1:   push      dx                       ; disk pro rekalibraci
         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,7                     ; povel 7 - rekalibrace
         mov       ah,2                     ; poet bajt = 2
         call      NECOutp                  ; vysln povelu na adi
         pop       dx                       ; nvrat disku pro rekalibraci
         jnz       Seek5                    ; byla chyba adie

; ------ kontrola vsledku rekalibrace - u mechanik 80 stop opakovn

         call      ChkStat                  ; kontrola vsledku operace
         loopnz    Seek1                    ; chyba - dal pokus pro 80 stop
         jnz       Seek5                    ; byla chyba operace

; ------ po rekalibraci jsou hlavy nastaveny na 0 - pi stop 0 konec operace

         or        dh,dh                    ; byla stopa 0 ?
         jz        Seek6                    ; byla stopa 0-ji jen ustlen hlav

; ------ zdvojen kroku pro disketu 360 KB

Seek2:   call      GetMed                   ; poskytnut bajtu stavu mdia
         test      al,20h                   ; m bt dvoj krokovn ?
         jz        Seek3                    ; nen dvoj krokovn
         shl       dh,1                     ; zdvojen sla stopy

; ------ test, zda je stopa ji nastaven

Seek3:   call      GetSeek                  ; poskytnut aktuln stopy
         cmp       al,dh                    ; je stopa ji nastavena ?
         je        Seek4                    ; stopa je ji nastavena
         mov       al,dh                    ; nov poadovan stopa
         call      SetSeek                  ; nastaven nov stopy

; ------ vysln povelu pro vystaven na zadanou stopu

         push      dx                       ; poadovan stopa a disk
         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,0fh                   ; povel pro vystaven hlav SEEK
         mov       ah,3                     ; poet bajt povelu
         call      NECOutp                  ; vysln povelu na adi
         pop       dx                       ; nvrat poadovan stopy a disku
         jnz       Seek5                    ; chyba vystaven

; ------ kontrola operace vystaven

         call      ChkStat                  ; kontrola vsledku operace
         jnz       Seek5                    ; byla chyba vystaven

; ------ ekn na ustlen hlav

Seek6:   call      HdWait                   ; ekn na ustlen hlav
Seek4:   xor       ah,ah                    ; pznak - operace OK
Seek5:   or        ah,ah                    ; nastaven pznaku ZF
         pop       dx
         ret

Seek     ENDP

; -----------------------------------------------------------------------------
;        ekn na ustlen hlav po vystaven
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   HdWait
HdWait   PROC      NEAR

         push      ax

; ------ zjitn doby pro ustlen hlav

         mov       al,9                     ; parametr 9 - doba pro ustlen
         call      GetPar                   ; poskytnut parametru 9
         or        al,al                    ; je parametr definovan ?
         jnz       HdWait1                  ; parametr je definovan

; ------ doba ekn nedefinovan (je = 0) - automatick uren minim. doby

         call      TestWr                   ; test, zda je operace zpis
         jz        HdWait2                  ; je operace ten - nemus se ekat
         call      GetMed                   ; poskytnut bajtu stavu mdia
         or        al,al                    ; je mechanika 300 ot/min ?
         mov       al,20                    ; doba pro ustlen mech. 360 KB
         js        HdWait1                  ; je mechanika 300 ot/min
         mov       al,15                    ; doba pro mechaniku HD 1.2 MB

; ------ ekn na ustlen hlav po dobu AL milisekund

HdWait1: mov       ah,33                    ; poet cykl 30 us pro dobu 1 ms
         mul       ah                       ; vpoet ekac doby (AX)
         call      WaitT                    ; nepodmnn ekn

HdWait2: pop       ax
         ret

HdWait   ENDP





; *****************************************************************************
;        Ovldn povel adie
; *****************************************************************************

; -----------------------------------------------------------------------------
;        Zjitn stavovho bajtu disku ST3
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AH=nvratov chybov kd
;        AL=stavov bajt disku ST3
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; -----------------------------------------------------------------------------

PUBLIC   DrivStat
DrivStat PROC      NEAR

         push      cx

; ------ vysln povelu SENSE DRIVE STATUS

         mov       cl,bl                    ; poadovan disk
         and       cl,1                     ; disk relativn (0 nebo 1)
         push      cx                       ; poadovan disk
         mov       si,sp                    ; ukazatel dat v zsobnku
         mov       al,4                     ; povel SENSE DRIVE STATUS
         mov       ah,2                     ; poet bajt
         call      NECOutp                  ; vysln povelu SENSE DRIVE STATUS
         pop       cx                       ; nvrat poadovanho disku
         jnz       DrivSt1                  ; chyba operace

; ------ navrcen stavovho registru ST3

         call      Result                   ; pjem vsledku operace
         jnz       DrivSt1                  ; byla chyba operace
         xor       al,al                    ; parametr 0 - registr ST3
         call      GetRes                   ; poskytnut registru 3

DrivSt1: or        ah,ah
         pop       cx
         ret

DrivStat ENDP

; -----------------------------------------------------------------------------
;        Kontrola vsledku operace vystaven, rekalibrace, resetu
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AH=nvratov chybov kd
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   ChkStat
ChkStat  PROC      NEAR

; ------ ekn na peruen od adie

         call      WaitInt                  ; ekn na peruen od adie
         jnz       ChkStat1                 ; byla chyba TIME-OUT

; ------ vysln povelu SENSE INTERRUPT STATUS

         mov       al,8                     ; povel SENSE INTERRUPT STATUS
         mov       ah,1                     ; poet bajt k vysln = 1
         call      NECOutp                  ; vysln povelu SENSE INTERRUPT ...
         jnz       ChkStat1                 ; byla chyba operace

; ------ pjem vsledku operace od adie

         call      Result                   ; pjem vsledku operace od adie
         jnz       ChkStat1                 ; byla chyba adie

; ------ kontrola navrcenho stavovho bajtu ST0

         xor       al,al                    ; AH <- 0 offset bajtu ST0
         call      GetRes                   ; poskytnut stavovho bajtu ST0
         and       al,01100000b             ; kontrolovan bity
         cmp       al,01100000b             ; je chyba vystaven ?
         mov       ah,40h                   ; chyba vystaven
         je        ChkStat1                 ; byla chyba vystaven
         xor       ah,ah                    ; operace probhla OK

ChkStat1:or        ah,ah                    ; nastaven pznaku ZF
         ret

ChkStat  ENDP



; -----------------------------------------------------------------------------
;        ekn na proveden operace ten/zpis/verifikace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AH=nvratov chybov kd
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   NECWait
NECWait  PROC      NEAR

         call      WaitInt                  ; ekn na peruen od adie
         push      ax                       ; schova navrcenho kdu chyby
         call      Result                   ; pjem vsledku operace
         mov       cl,ah                    ; schova kdu chyby
         pop       ax                       ; nvrat chyby z WaitInt
         or        ah,ah                    ; byla chyba ekn na peruen ?
         jnz       NECWait1                 ; byla chyba ekn na peruen
         or        ah,cl                    ; byla chyba pjmu vsledku ?
         jnz       NECWait1                 ; byla chyba pjmu vsledku
         call      ErrCode                  ; sestaven chybovho kdu
NECWait1:ret

NECWait  ENDP


; -----------------------------------------------------------------------------
;        Sestaven kdu chyby
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        DS=CS
;        ES=0
; VSTUP:AH=nvratov chybov kd
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   ErrCode
ErrCode  PROC      NEAR

; ------ test, zda je njak chyba

         xor       al,al                    ; AL <- 0 (offset bajtu 0)
         call      GetRes                   ; poskytnut stavovho bajtu ST0
         and       al,0c0h                  ; je njak chyba ?
         jz        ErrCode1                 ; nen chyba

; ------ test, zda je nedokonen operace nebo vnitn chyba adie

         cmp       al,40h                   ; je nedokonen operace ?
         mov       ah,20h                   ; chyba adie
         jne       ErrCode1                 ; jin chyba ne nedokonen oper.

; ------ sektor nenalezen nebo velk slo sektoru

         mov       al,1                     ; AL <- 1 (offset bajtu ST1)
         call      GetRes                   ; poskytnut stav. bajtu ST1
         test      al,84h                   ; konec stopy nebo sektor nenalezl ?
         mov       ah,4                     ; chyba - sektor nenalezen
         jnz       ErrCode1                 ; sektor nenalezen

; ------ chybn kontroln souet dat sektoru

         test      al,20h                   ; chyba kontrolnho soutu CRC ?
         mov       ah,10h                   ; kd chyby kontr. soutu CRC dat
         jnz       ErrCode1                 ; byla chyba CRC dat

; ------ chyba peteen DMA pes hranici

         test      al,10h                   ; bylo peteen dat ?
         mov       ah,8                     ; kd chyby peteen DMA
         jnz       ErrCode1                 ; bylo peteen adresy DMA

; ------ chyba zpisu na disketu s ochranou zpisu

         test      al,2                     ; byla ochrana proti zpisu ?
         mov       ah,3                     ; kd chyby ochrany proti zpisu
         jnz       ErrCode1                 ; byla ochrana proti zpisu

; ------ chyba - nenalezena adresov znaka

         test      al,1                     ; nelze nalst adresovou znaku ?
         mov       ah,2                     ; kd chyby - nenalezena adr. znaka
         jnz       ErrCode1                 ; chyba nenalezen adres. znaky

; ------ chybu nelze urit - chyba adie

         mov       ah,20h                   ; chyba adie

ErrCode1:or        ah,ah                    ; nastaven pznaku chyby ZF
         ret

ErrCode  ENDP



; -----------------------------------------------------------------------------
;        Vysln povelu na adi
; -----------------------------------------------------------------------------
; VSTUP: BL=disk
;        AL=prvn bajt k vysln
;        AH=poet bajt celkem k vysln
;        SS:SI=data (v zsobnku)
;        DS=CS
;        ES=0
; VSTUP:AH=nvratov chybov kd
;        ZY=operace OK (AH=0), NZ=chyba operace (AH nen 0)
; Znien registry: AX, SI
; -----------------------------------------------------------------------------

PUBLIC   NECOutp
NECOutp  PROC      NEAR

         push      cx
         push      dx

; ------ ekn na pipravenost adie pijmat data

NECOutp1:push      ax                       ; schova bajtu k vysln
         mov       ah,80h                   ; oekvan hodnota
         call      WaitPort                 ; ekn na stav portu
         pop       cx                       ; nvrat bajtu k vysln
         jnz       NECOutp4                 ; byla chyba TIME-OUT

; ------ vysln bajtu na adi

         call      GetPrt5                  ; povelov registr adie
         mov       ax,cx                    ; nvrat AH a AL
         out       dx,al                    ; vysln bajtu na adi

; ------ ekn na potvrzen pevzet bajtu

         dec       dx                       ; stavov registr adie
         mov       cx,24                    ; maximln doba pro ekn
NECOutp2:in        al,dx                    ; ten stavu adie
         test      al,80h                   ; pevzal adi bajt ?
         loopnz    NECOutp2                 ; ekn na pevzet bajtu

; ------ test, zda je dal bajt k vysln

         dec       ah                       ; snen tae bajt k vysln
         jz        NECOutp3                 ; nen ji dal bajt k vysln
         mov       al,ss:[si]               ; dal bajt k vysln
         inc       si                       ; zven ukazatele dat v zsobnku
         jmp       short NECOutp1           ; vysln dalho bajtu

NECOutp3:xor       ah,ah

NECOutp4:or        ah,ah                    ; nastaven pznaku ZF
         pop       dx
         pop       cx
         ret

NECOutp  ENDP


; -----------------------------------------------------------------------------
;        Pjem stavu od adie
; -----------------------------------------------------------------------------
; VSTUP: BL=disk
;        DS=CS
;        ES=0
; VSTUP:AH=kd chyby (0=operace OK)
;        ZY=operace OK, NZ=chyba operace
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   Result
Result   PROC      NEAR

         push      bx
         push      dx
         xor       bh,bh                    ; ukazatel bajtu k uloen

; ------ ekn na pipravenost adie

Result1: mov       ah,0c0h                  ; poadovan hodnota
         call      WaitPort                 ; ekn na pipravenost adie
         jnz       Result2                  ; byla chyba adie TIME-OUT

; ------ pjem stavovho bajtu od adie

         call      GetPrt5                  ; datov registr adie
         in        al,dx                    ; ten stavovho bajtu adie
         mov       ah,bh                    ; offset registru vsledku
         call      SetRes                   ; uloen stavovho bajtu
         inc       bh                       ; zven ukazatele bajt

; ------ mal prodleva

         mov       ax,3
         call      WaitT                    ; ekac doba pro odezvu adie

; ------ test, zda je jet dal stavov bajt

         dec       dx                       ; stavov registr adie
         in        al,dx                    ; ten stavu adie
         test      al,10h                   ; je jet dal stavov bajt ?
         mov       ah,0                     ; nvratov kd operace - OK
         jz        Result2                  ; nen ji dal bajt
         mov       ah,20h                   ; pznak - chyba adie
         cmp       bh,6                     ; pekroen poet stavovch bajt ?
         jbe       Result1                  ; pjem dalho stavovho bajtu

Result2: or        ah,ah                    ; test vsledku operace
         pop       dx
         pop       bx
         ret

Result   ENDP


; -----------------------------------------------------------------------------
;        ekn na peruen od adie
; -----------------------------------------------------------------------------
; VSTUP: DS=CS
;        ES=0
; VSTUP:AH=kd chyby (0=operace OK)
;        ZY=operace OK, NZ=chyba operace TIME-OUT
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   WaitInt
WaitInt  PROC      NEAR

; ------ zahjen ekn

         cmp       byte ptr ds:[WaitAT],1   ; me se oznmit ekn ?
         jne       WaitInt1                 ; ekn se neoznamuje
         clc                                ; pednastaven pznaku NC
         mov       ax,9001h
         int       15h                      ; zahjen operace ekn
         jc        WaitInt3                 ; chyba TIME-OUT

; ------ ekn na pchod peruen INT 0eh (po dobu 1.5 sekundy)

WaitInt1:xor       ah,ah                    ; pednastaven operace OK
         mov       byte ptr ds:[Counter],18+9 ; doba pro 1.5 sekundy
WaitInt2:test      byte ptr es:[43eh],80h   ; pilo ji peruen ?
         jnz       WaitInt4                 ; pilo ji peruen INT 0eh
         cmp       byte ptr ds:[Counter],0  ; uplynula ji maximln doba ?
         jne       WaitInt2                 ; jet neuplynula maximln doba

; ------ chyba TIME-OUT ekn

WaitInt3:mov       ah,80h                   ; pznak chyby TIME-OUT

WaitInt4:and       byte ptr es:[43eh],not 80h ; nulovn pznaku peruen
         or        ah,ah                    ; test vsledku operace (NZ)
         ret

WaitInt  ENDP




; *****************************************************************************
;        Ovldn motoru
; *****************************************************************************

; -----------------------------------------------------------------------------
;        Zapnut motoru disku
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   MotorOn
MotorOn  PROC      NEAR

         push      ax
         push      cx
         push      dx

; ------ doba pro vypnut motoru na maximum

         mov       al,0ffh                  ; inicializan doba pro vypnut
         call      SetMOff                  ; nastaven doby pro vypnut

; ------ sestaven novho stavovho bajtu motor

         call      GetMot                   ; poskytnut stav motor
         mov       ah,al                    ; schova starho stavu motor
         and       al,not 30h               ; zruen pvodnho aktivnho disku
         mov       ch,1                     ; maska pro motor disku 0 (2)
         test      bl,1                     ; je relativn disk 0 nebo 1 ?
         jz        MotorOn1                 ; je disk 0 (nebo 2)
         inc       ch                       ; maska pro motor disku 1 (3)
         or        al,10h                   ; nov aktivn disk 1
MotorOn1:or        al,ch                    ; pznak zapnut motoru
         call      SetMot                   ; nastaven novho stavu motor

; ------ zapnut motoru mechaniky

         mov       cl,4                     ; poet rotac
         rol       al,cl                    ; rotace na sprvnou pozici
         or        al,0ch                   ; bity pro uvolnn adie
         call      GetPrt2                  ; dic registr adie
         out       dx,al                    ; zapnut motor

; ------ test, zda se bude ekat

         sti                                ; povolen peruen
         test      ah,ch                    ; byl motor zapnut ?
         jnz       MotorOn6                 ; motor byl ji zapnut - neek se

; ------ zahjen ekn

         cmp       byte ptr ds:[WaitAT],1   ; me se oznmit ekn ?
         jne       MotorOn2                 ; ekn se neoznamuje
         clc                                ; pednastaven pznaku NC
         mov       ax,90fdh
         int       15h                      ; zahjen ekn
         jc        MotorOn6                 ; ekn se vyhovlo - konec

; ------ doba pro start motoru

MotorOn2:mov       al,10                    ; parametr 10 - as pro start motoru
         call      GetPar                   ; poskytnut parametru 10

; ------ minimln startovac doba pro zpis

         call      TestWr                   ; test - je operace zpis ?
         jz        MotorOn3                 ; nen zpis - je ten
         cmp       al,7                     ; minimln startovac doba 7
         ja        MotorOn4                 ; startovac doba je dostaten
         mov       al,8                     ; minimln startovac doba zpisu
         jmp       short MotorOn4           ; pokraovn

; ------ minimln startovac doba pro ten

MotorOn3:or        al,al                    ; je startovac doba = 0 ?
         jz        MotorOn6                 ; nen potebn startovac doba
         cmp       al,4                     ; je doba alespo 4 ?
         ja        MotorOn4                 ; startovac doba je dostaten
         mov       al,4                     ; minimln startovac doba 4

; ------ ekn po zadanou dobu na start motoru

MotorOn4:mov       ah,al                    ; poadovan doba v 1/8 sekund
         add       al,al                    ; pevod z 1/8 sekundy na 1/16 sek.
         shr       ah,1
         shr       ah,1                     ; 1/4 poadovan doby
         add       al,ah                    ; pevod z 1/16 sekundy na 1/18 sek.
         mov       byte ptr ds:[Counter],al ; nastaven tae dlouhho asu
MotorOn5:cmp       byte ptr ds:[Counter],0  ; uplynul ji as ?
         jne       MotorOn5                 ; as jet neuplynul

MotorOn6:pop       dx
         pop       cx
         pop       ax
         ret

MotorOn  ENDP


; *****************************************************************************
;        Urovn typu mdia
; *****************************************************************************



; -----------------------------------------------------------------------------
;        Obsluha vmny mdia (se zapnutm motoru)
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AH=kd chyby (0=operace OK)
;        ZY=operace OK, NZ=chyba operace TIME-OUT nebo mdium vymnno
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   MedChng0                           ; test vmny bez zapnut motoru
PUBLIC   MedChng
MedChng  PROC      NEAR

         call      MotorOn                  ; zapnut motoru

; ------ pro mechaniku 40 stop se kontrola neprovd - disketa nevymnna

MedChng0:call      GetStat                  ; ten stavovho bajtu mechaniky
         test      al,1                     ; je mechanika 40 stop ?
         jz        MedChng4                 ; je mechanika 40 stop - nevymnna

; ------ ten stavu vmny mdia

         call      ReadChng                 ; ten signlu vmny mdia
MedChng4:mov       ah,0                     ; nvratov kd - mdium nevymnno
         jz        MedChng3                 ; mdium nebylo vymnno

; ------ nulovn pznaku znmosti mdia

         call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,not 10h               ; nulovn pznaku znmosti mdia
         call      SetMed                   ; optn nastaven bajtu stavu mdia

; ------ nulovn signlu vmny mdia

         mov       ah,bl                    ; disk
         and       ah,1                     ; disk 0 nebo 1
         inc       ah                       ; maska rekalibrace (1 nebo 2)
         call      GetRec                   ; poskytnut bajtu rekalibrace
         test      al,ah                    ; vyaduje se rekalibrace ?
         jz        MedChng1                 ; nen znm aktuln stopa
         call      GetSeek                  ; poskytnut aktuln stopy
         or        al,al                    ; je jin stopa ne 0 ?
         jnz       MedChng2                 ; nen nutn vystaven na stopu 1
MedChng1:mov       al,1                     ; poadovan stopa 1
         call      Seek                     ; vystaven na stopu 1
MedChng2:xor       al,al                    ; poadovan stopa 0
         call      Seek                     ; vystaven na stopu 0

; ------ test, zda se signl vmny zmnil - pokud ne, jsou dvka otevena

         call      ReadChng                 ; ten signlu vmny mdia
         mov       ah,6                     ; pznak - mdium vymnno
         jz        MedChng3                 ; signl vmny OK
         mov       ah,80h                   ; pznak - mechanika nepipravena

MedChng3:or        ah,ah
         ret

MedChng  ENDP

; -----------------------------------------------------------------------------
;        Test dvojho krokovn
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AH=kd chyby (0=operace OK)
;        ZY=operace OK, NZ=chyba operace TIME-OUT
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   SetDbl
SetDbl   PROC      NEAR

         push      dx

; ------ test, zda je mdium znm

         call      GetMed                   ; ten bajtu stavu mdia
         test      al,10h                   ; je mdium znm ?
         jnz       SetDbl5                  ; mdium je znm
         and       al,not 20h               ; nulovn pznaku dvojho krokov.
         call      SetMed                   ; nastaven bajtu stavu mdia

; ------ pro mechaniku 40 stop se test neprovd

         call      GetStat                  ; ten stavovho bajtu mechaniky AL
         test      al,1                     ; je disketa 40 stop ?
         jz        SetDbl5                  ; je disketa 40 stop

; ------ nulovn pznaku rekalibrace

         call      NulRec                   ; nulovn pznaku rekalibrace

; ------ vystaven na stopu 0 (a potom i na dal stopy)

         mov       dl,bl                    ; poadovan disk
         and       dl,1                     ; poadovan disk relativn
         xor       dh,dh                    ; poten stopa 0
SetDbl2: mov       al,dh                    ; poadovan stopa
         call      Seek                     ; vystaven disku AL na stopu AH
         jnz       SetDbl6                  ; byla chyba vystaven

; ------ pokus o ten identifiktoru

         push      dx                       ; poadovan disk
         mov       si,sp                    ; ukazatel parametr
         mov       al,4ah                   ; povel pro ten identifiktoru ID
         mov       ah,2                     ; poet parametr READ ID
         call      NECOutp                  ; vysln povelu READ ID na adi
         pop       dx                       ; zruen dat v zsobnku
         jnz       SetDbl6                  ; byla chyba operace

; ------ test, zda byl ID nalezen

         call      NECWait                  ; ekn na proveden operace
         mov       al,0ffh                  ; maximln doba vypnut motoru
         call      SETMOff                  ; nastaven doby pro vypnut motoru
         or        dh,dh                    ; byla to stopa 0 ?
         jz        SetDbl3                  ; byla to stopa 0
         or        ah,ah                    ; byla njak chyba ?
         jz        SetDbl4                  ; nebyla chyba - ID nalezen

; ------ ID nenalezen - dal stopa (a po stopu asi tak 20 - 8 pokus)

         add       dh,2                     ; zven sla stopy (sud stopy)
         cmp       dh,20                    ; je ji stopa 20 ?
         jb        SetDbl2                  ; nen jet stopa 20
         jmp       short SetDbl6            ; chyba - nenalezeno

; ------ byla stopa 0 - test, zda je vbec iteln

SetDbl3: or        ah,ah                    ; byla stopa 0 iteln ?
         jnz       SetDbl6                  ; nen iteln-nem smysl pokraovat
         mov       dh,4                     ; dal stopa bude stopa 4
         jmp       short SetDbl2            ; pokus o ten stopy 4

; ------ ID nalezen - pokud stopa nesouhlas, je dvoj krokovn

SetDbl4: mov       al,3                     ; poadovan bajt - stopa ID
         call      GetRes                   ; poskytnut parametru 3
         cmp       al,dh                    ; souhlas stopa ?
         je        SetDbl5                  ; stopa souhlas - je 80 stop
         call      GetMed                   ; poskytnut bajtu stavu mdia
         or        al,20h                   ; pznak dvojho krokovn
         call      SetMed                   ; nastaven bajtu stavu mdia

SetDbl5: xor       ah,ah                    ; pznak - operace OK

SetDbl6: or        ah,ah                    ; nastaven pznaku ZF
         pop       dx
         ret

SetDbl   ENDP



; -----------------------------------------------------------------------------
;        Uren implicitnho bajtu stavu mdia (pro formtovn)
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; Znien registry: AX
; -----------------------------------------------------------------------------

PUBLIC   MedDet
MedDet   PROC      NEAR

; ------ uren stavovho bajtu mdia podle typu mechaniky

         push      bx                       ; schova BX
         call      GetTyp                   ; poskytnut typu disku
         mov       bl,al                    ; typ disku
         xor       bh,bh                    ; BH <- 0
         mov       ah,ds:[TabMed+bx]        ; konverze na typ mdia
         pop       bx                       ; nvrat BX

; ------ uren stavovho bajtu mechaniky 720 KB (rozlien 5 1/4" nebo 3 1/2")

         cmp       al,3                     ; je mechanika 720 KB ?
         jne       MedDet2                  ; nen mechanika 720 KB
         call      GetStat                  ; poskytnut stavovho bajtu disku
         and       al,6                     ; pznak vce rychlost
         cmp       al,6                     ; je mon vce rychlost ?
         jne       MedDet2                  ; nen mon vce rychlost
         mov       ah,50h                   ; rychlost 300 kb/s pro mech. 5 1/4"

; ------ nastaven stavovho bajtu mdia

MedDet2: mov       al,ah                    ; nov hodnota bajtu stavu mdia
         call      SetMed                   ; nastaven bajtu stavu mdia
         ret

MedDet   ENDP

TabMed   db        0                        ; 0: neuren mdium
         db        93h                      ; 1: 360 KB (250 k/s)
         db        15h                      ; 2: 1.2 MB (500 k/s)
         db        97h                      ; 3: 720 KB (50h) (250 k/s, 300 k/s)
         db        17h                      ; 4: 1.44 MB (500 k/s)

; -----------------------------------------------------------------------------
;        Uren tabulky disku podle typu disku
; -----------------------------------------------------------------------------
; VSTUP: AL=typ disketov mechaniky 1 a 4
; VSTUP:CS:SI=adresa tabulky disku
; -----------------------------------------------------------------------------

PUBLIC   GetTab
GetTab   PROC      NEAR

         push      ax                       ; schova AX
         mov       ah,13                    ; dlka 1 tabulky
         mul       ah                       ; vpoet offsetu tabulky
         mov       si,ax                    ; offset tabulky
         pop       ax                       ; nvrat AX
         cmp       al,2                     ; byl disk 1 nebo 2 ?
         ja        GetTab1                  ; je mechanika 720 KB nebo 1.44 MB
         sub       si,13                    ; disky 1, 2 (pesko 1.2M v 1.2M)
GetTab1: add       si,offset TabDisk        ; tabulka disk
         ret

GetTab   ENDP


; -----------------------------------------------------------------------------
;        ten signlu vmny mdia
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=stav signlu vmny (0=nebyla vmna, 80h=byla vmna)
;        ZY=nebyla vmna, NZ=disketa vymnna
; -----------------------------------------------------------------------------

PUBLIC   ReadChng
ReadChng PROC      NEAR

         push      dx                       ; schova DX
         call      GetPrt7                  ; poskytnut adresy portu 7
         in        al,dx                    ; ten stavu signlu vmny
         and       al,80h                   ; test bitu signlu vmny
         pop       dx                       ; nvrat DX
         ret

ReadChng ENDP



; *****************************************************************************
;        Obsluha penosov rychlosti
; *****************************************************************************



; -----------------------------------------------------------------------------
;        Inicializace koncov penosov rychlosti (poten je aktuln)
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   SetupSt
SetupSt  PROC      NEAR

; ------ pro disk s 1 rychlost pouze rychlost 250 k/s

         call      GetStat                  ; ten stavovho bajtu disku
         and       al,6                     ; stavov bity
         cmp       al,4                     ; je pouze 1 rychlost ?
         mov       al,80h                   ; koncov rychlost 250 kb/s
         je        SetupSt2                 ; je pouze 1 rychlost

; ------ uren maximln rychlosti pi vce rychlostech

         call      GetMed                   ; poskytnut stavovho bajtu mdia
         and       al,0c0h                  ; aktuln penosov rychlost
         add       al,40h                   ; 00h (500) -> 40h (300)
                                            ; 40h (300) -> 80h (250)
                                            ; 80h (250) -> 0c0h (korekce na 00h)
                                            ; 0c0h (neplatn) -> 00h
         cmp       al,0c0h                  ; bude korekce ?
         jne       SetupSt2                 ; nebude korekce
         xor       al,al                    ; korekce 80h->00h (250->500)

; ------ nastaven nov maximln rychosti

SetupSt2:call      SetMRate                 ; nastaven maximln rychlosti
         ret

SetupSt  ENDP

; -----------------------------------------------------------------------------
;        Nastaven penosov rychlosti (podle stavovho bajtu mdia)
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SendRate
SendRate PROC      NEAR

; ------ kontrola, zda je rychlost ji nastavena

         push      ax
         push      dx
         call      GetLRate                 ; poskytnut posledn penos. rychl.
         mov       ah,al                    ; posledn penos. rychlost
         call      GetMed                   ; poskytnut stavovho bajtu mdia
         and       al,0c0h                  ; poadovan penosov rychlost
         cmp       al,ah                    ; je rychlost ji nastavena ?
         je        SendRat2                 ; rychlost je ji nastavena

; ------ nastaven nov penosov rychlosti

         call      SetLRate                 ; nastaven posledn penos. rychl.
         call      GetPrt7                  ; poskytnut adresy portu 7
         rol       al,1
         rol       al,1                     ; rychlost -> bity 0 a 1 reg. AL
         out       dx,al                    ; nastaven penosov rychlosti

SendRat2:pop       dx
         pop       ax
         ret

SendRate ENDP

; -----------------------------------------------------------------------------
;        Nastaven dal penosov rychlosti 300->500->250 (40h->00h->80h)
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AH=kd chyby z pedel operace
;        DS=CS
;        ES=0
; VSTUP:AH=pvodn kd chyby nebo 0 - lze provst dal pokus
; -----------------------------------------------------------------------------

PUBLIC   Retry
Retry    PROC      NEAR

; ------ test, zda ji byla maximln rychlost

         push      bx                       ; schova BX
         mov       bh,ah                    ; schova nvratovho kdu
         call      GetMRate                 ; poskytnut max. penos. rychlosti
         mov       ah,al                    ; schova maxim. penos. rychlosti
         call      GetMed                   ; poskytnut bajtu stavu mdia
         and       al,0c0h                  ; aktuln penosov rychlost
         cmp       al,ah                    ; byla ji posledn rychlost ?
         mov       ah,bh                    ; pvodn nvratov kd chyby
         je        Retry3                   ; byly ji vechny pokusy - chyba

; ------ uren dal penosov rychlosti

         call      GetMed                   ; poskytnut bajtu stavu mdia
         add       al,0c0h                  ; 00h -> 0c0h (bude korekce na 80h)
                                            ; 40h -> 00h
                                            ; 80h -> 40h
                                            ; 0c0h -> 80h

         jns       Retry2                   ; nen bajt 0c0h ani 80h
         and       al,not 40h               ; korekce na 80h
Retry2:  call      SetMed                   ; nastaven bajtu stavu mdia
         xor       ah,ah                    ; AH <- 0 pznak monosti opakovn

Retry3:  or        ah,ah                    ; je mon opakovn ?
         pop       bx
         ret

Retry    ENDP

; -----------------------------------------------------------------------------
;        Uren typu mdia a disku po spn operaci ten/zpis/verifikace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   DState
DState   PROC      NEAR

         push      ax

; ------ oznaen mdia za uren

         call      GetMed                   ; poskytnut bajtu stavu mdia
         or        al,10h                   ; oznaen mdia jako uren
         call      SetMed                   ; nastaven bajtu stavu mdia
         mov       ah,al                    ; schova bajtu stavu mdia

; ------ test, zda byla mechanika ji urena

         call      GetStat                  ; ten stavovho bajtu mechaniky
         test      al,4                     ; je mechanika ji urena ?
         jnz       DState2                  ; mechanika je ji urena

; ------ uren typu mechaniky (rozlien, zda je mon vce rychlost)

         or        al,6                     ; mechanika uren, vce rychlost
         and       ah,0c0h                  ; penosov rychlost
         cmp       ah,80h                   ; byla rychlost 250 k/s ?
         jne       DState1                  ; nebyla rychlost 250 k/s
         mov       ah,al                    ; schova bajtu mechaniky
         call      GetTyp                   ; poskytnut typu disku AL
         xchg      ah,al                    ; AH <- typ mechaniky
         jz        DState1                  ; disk nen instalovn
         cmp       ah,4                     ; je mechanika 3 1/2" HD ?
         je        DState1                  ; je mechanika 3 1/2" HD
         and       al,not 2                 ; pznak, e je jen rychlost 250k/s
DState1: call      SetStat                  ; nastaven stavovho bajtu disku

DState2: pop       ax
         ret

DState   ENDP


; *****************************************************************************
;        Nastavovn promnnch
; *****************************************************************************


; -----------------------------------------------------------------------------
;        Poskytnut bajtu vsledku operace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=offset bajtu (slo 0 - 6)
;        ES=0
;        DS=CS
; VSTUP:AL=bajt vsledku operace
; -----------------------------------------------------------------------------

PUBLIC   GetRes
GetRes   PROC      NEAR

         push      bx                       ; schova BX
         xor       bh,bh                    ; BH <- 0
         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         mov       bl,al                    ; offset bajtu
         mov       al,es:[442h+bx]          ; bajty pro disky 0 a 1
         jb        GetRes1                  ; jsou disky 0 nebo 1
         mov       al,ds:[Stat+bx]          ; bajty pro disky 2 a 3
GetRes1: pop       bx
         ret

GetRes   ENDP

; -----------------------------------------------------------------------------
;        Nastaven bajtu vsledku operace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=nastavovan hodnota
;        AH=offset bajtu (slo 0 - 6)
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetRes
SetRes   PROC      NEAR

         push      bx                       ; schova BX

         xor       bh,bh                    ; BH <- 0
         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         mov       bl,ah                    ; offset bajtu
         jb        SetRes1                  ; jsou disky 0 nebo 1

; ------ nastaven bajtu disk 2 a 3

         mov       ds:[Stat+bx],al          ; nastaven bajtu disk 2 a 3
         jmp       short SetRes2

; ------ nastaven bajtu disk 0 a 1

SetRes1: mov       es:[442h+bx],al          ; nastaven bajtu disk 0 a 1

SetRes2: pop       bx
         ret

SetRes   ENDP

;; -----------------------------------------------------------------------------
;;        Poskytnut bajtu tae vypnut motor
;; -----------------------------------------------------------------------------
;; VSTUP: BL=slo disku
;;        ES=0
;;        DS=CS
;; VSTUP:AL=bajt tae vypnut motor
;; -----------------------------------------------------------------------------
;
;PUBLIC   GetMOff
;GetMOff  PROC      NEAR
;
;         mov       al,ds:[CountMot]         ; ta motor disk 2 a 3
;         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
;         jae       GetMOff1                 ; je disk 2 nebo 3
;         mov       al,es:[440h]             ; ta motor disk 0 a 1
;GetMOff1:ret
;
;GetMOff  ENDP

; -----------------------------------------------------------------------------
;        Nastaven bajtu tae vypnut motor
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=bajt tae vypnut motor
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetMOff
SetMOff  PROC      NEAR

;         mov       ds:[CountMot],al         ; ta motor disk 2 a 3
         mov       es:[440h],al             ; ta motor disk 0 a 1
         ret

SetMOff  ENDP


; -----------------------------------------------------------------------------
;        Nulovn pznaku rekalibrace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   NulRec
NulRec   PROC      NEAR

         push      ax
         mov       ah,bl                    ; disk
         and       ah,1                     ; disk 0 nebo 1
         inc       ah                       ; maska rekalibrace (1 nebo 2)
         not       ah                       ; inverzn maska
         call      GetRec                   ; poskytnut bajtu rekalibrace
         and       al,ah                    ; nulovn bitu rekalibrace
         call      SetRec                   ; nastaven novho bajtu rekalibrace
         pop       ax
         ret

NulRec   ENDP

; -----------------------------------------------------------------------------
;        Poskytnut bajtu rekalibrace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=bajt stavu rekalibrace
; -----------------------------------------------------------------------------

PUBLIC   GetRec
GetRec   PROC      NEAR

         mov       al,ds:[Rekalib]          ; stav rekalibrace disk 2 a 3
         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         jae       GetRec1                  ; je disk 2 nebo 3
         mov       al,es:[43eh]             ; stav rekalibrace disk 0 a 1
GetRec1: ret

GetRec   ENDP

; -----------------------------------------------------------------------------
;        Nastaven bajtu rekalibrace
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=bajt rekalibrace
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetRec
SetRec   PROC      NEAR

         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         jb        SetRec1                  ; je disk 0 nebo 1
         mov       ds:[Rekalib],al          ; stav rekalibrace disk 2 a 3
         ret

SetRec1: mov       es:[43eh],al             ; stav rekalibrace disk 0 a 1
         ret

SetRec   ENDP

; -----------------------------------------------------------------------------
;        Poskytnut bajtu stavu motor
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=bajt stavu motor
; -----------------------------------------------------------------------------

PUBLIC   GetMot
GetMot   PROC      NEAR

         mov       al,ds:[Motors]           ; stav motor disk 2 a 3
         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         jae       GetMot1                  ; je disk 2 nebo 3
         mov       al,es:[43fh]             ; stav motor disk 0 a 1
GetMot1: ret

GetMot   ENDP

; -----------------------------------------------------------------------------
;        Nastaven bajtu stavu motor
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=bajt stavu motor
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetMot
SetMot   PROC      NEAR

         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         jb        SetMot1                  ; je disk 0 nebo 1
         mov       ds:[Motors],al           ; stav motor disk 2 a 3
         ret

SetMot1: mov       es:[43fh],al             ; stav motor disk 0 a 1
         ret

SetMot   ENDP

; -----------------------------------------------------------------------------
;        Nulovn pznaku operace zpis
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   ResWr
ResWr    PROC      NEAR

         cmp       bl,2
         jb        ResWr1
         and       byte ptr ds:[Motors],not 80h ; nulovn pznaku zpis
         ret

ResWr1:  and       byte ptr es:[43fh],not 80h ; nulovn pznaku zpis
         ret

ResWr    ENDP

; -----------------------------------------------------------------------------
;        Nastaven pznaku operace zpis
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetWr
SetWr    PROC      NEAR

         cmp       bl,2
         jb        SetWr1
         or        byte ptr ds:[Motors],80h ; nastaven pznaku zpis
         ret

SetWr1:  or        byte ptr es:[43fh],80h   ; nastaven pznaku zpis
         ret

SetWr    ENDP

; -----------------------------------------------------------------------------
;        Test, zda je operace zpis
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:ZY=je ten, NZ=je zpis
; -----------------------------------------------------------------------------

PUBLIC   TestWr
TestWr   PROC      NEAR

         cmp       bl,2
         jb        TestWr1
         test      byte ptr ds:[Motors],80h ; test pznaku zpis
         ret

TestWr1: test      byte ptr es:[43fh],80h   ; test pznaku zpis
         ret

TestWr   ENDP

; -----------------------------------------------------------------------------
;        Poskytnut maximln penosov rychlosti
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=maximln penosov rychlost adie (bity 6 a 7)
; -----------------------------------------------------------------------------

PUBLIC   GetMRate
GetMRate PROC      NEAR

         mov       al,ds:[MaxRate]          ; maximln penos. rychlost
         cmp       bl,2                     ; je disk 2 nebo 3 ?
         jae       GetMRat1                 ; je disk 2 nebo 3 - je adi #2
         mov       al,es:[48bh]             ; maximln penos. rychl.
         shl       al,1
         shl       al,1
         shl       al,1
         shl       al,1                     ; rotace na pozice bit 6 a 7
GetMRat1:and       al,0c0h                  ; ponech bity penosov rychlosti
         ret

GetMRate ENDP

; -----------------------------------------------------------------------------
;        Nastaven maximln penosov rychlosti
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=maximln penosov rychlost adie (bity 6 a 7)
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetMRate
SetMRate PROC      NEAR

         push      ax
         and       al,0c0h                  ; ponech bity penos. rychlosti

; ------ nastaven pro adi #2

         cmp       bl,2                     ; je disk 2 nebo 3 ?
         jb        SetMRat1                 ; je disk 0 nebo 1 - je adi #1
         mov       ds:[MaxRate],al          ; maximln penos. rychlost
         jmp       short SetMRat2

; ------ nastaven pro adi #1

SetMRat1:and       byte ptr es:[48bh],not 0ch ; zruen pvodn penos. rychl.
         shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1                     ; rotace na pozice bit 2 a 3
         or        byte ptr es:[48bh],al    ; nov maximln penos. rychlost
SetMRat2:pop       ax
         ret

SetMRate ENDP

; -----------------------------------------------------------------------------
;        Poskytnut posledn penosov rychlosti
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=posledn nastaven penosov rychlost adie (bity 6 a 7)
; -----------------------------------------------------------------------------

PUBLIC   GetLRate
GetLRate PROC      NEAR

         mov       al,ds:[LastRate]         ; posledn nastaven penos.rychlost
         cmp       bl,2                     ; je disk 2 nebo 3 ?
         jae       GetLRat1                 ; je disk 2 nebo 3 - je adi #2
         mov       al,es:[48bh]             ; aktuln nastaven penos. rychl.
GetLRat1:and       al,0c0h                  ; ponech bity penosov rychlosti
         ret

GetLRate ENDP

; -----------------------------------------------------------------------------
;        Nastaven posledn penosov rychlosti
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=posledn nastaven penosov rychlost adie (bity 6 a 7)
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetLRate
SetLRate PROC      NEAR

         push      ax
         and       al,0c0h

; ------ nastaven pro adi #2

         cmp       bl,2                     ; je disk 2 nebo 3 ?
         jb        SetLRat1                 ; je disk 0 nebo 1 - je adi #1
         mov       ds:[LastRate],al         ; posledn nastaven penos.rychlost
         jmp       short SetLRat2

; ------ nastaven pro adi #1

SetLRat1:and       byte ptr es:[48bh],not 0c0h ; zruen pvodn penos. rychl.
         or        byte ptr es:[48bh],al    ; nov penosov rychlost
SetLRat2:pop       ax
         ret

SetLRate ENDP

; -----------------------------------------------------------------------------
;        Poskytnut aktuln stopy mechaniky AL
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=aktuln stopa disku
; -----------------------------------------------------------------------------

PUBLIC   GetSeek
GetSeek  PROC      NEAR

         mov       al,ds:[Stopa3]           ; aktuln stopa disku 3
         cmp       bl,2                     ; je disk 2 nebo 3 ?
         ja        GetSeek1                 ; je disk 3
         mov       al,ds:[Stopa2]           ; aktuln stopa disku 2
         je        GetSeek1                 ; je disk 2
         mov       al,es:[494h]             ; aktuln stopa disku 0
         or        bl,bl                    ; je disk 0 ?
         jz        GetSeek1                 ; je disk 0
         mov       al,es:[495h]             ; aktuln stopa disku 1
GetSeek1:ret

GetSeek  ENDP

; -----------------------------------------------------------------------------
;        Nastaven aktuln stopy disku
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=nov aktuln stopa
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetSeek
SetSeek  PROC      NEAR

         cmp       bl,2                     ; jsou disky 2 nebo 3 ?
         jb        SetSeek2                 ; jsou disky 0 nebo 1
         ja        SetSeek1                 ; je disk 3
         mov       ds:[Stopa2],al           ; nastaven stopy disku 2
         ret

SetSeek1:mov       ds:[Stopa3],al           ; nastaven stopy disku 3
         ret

SetSeek2:or        bl,bl                    ; je mechanika 0 ?
         jnz       SetSeek3                 ; je mechanika 1
         mov       es:[494h],al             ; nastaven mechaniky 0
         ret

SetSeek3:mov       es:[495h],al             ; nastaven mechaniky 1
         ret

SetSeek  ENDP

; -----------------------------------------------------------------------------
;        Poskytnut stavovho bajtu mdia mechaniky AL
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=stavov bajt mdia
; -----------------------------------------------------------------------------

PUBLIC   GetMed
GetMed   PROC      NEAR

         mov       al,ds:[Med3]             ; stav mdia disku 3
         cmp       bl,2                     ; je disk 2 nebo 3 ?
         ja        GetMed1                  ; je disk 3
         mov       al,ds:[Med2]             ; stav mdia disku 2
         je        GetMed1                  ; je disk 2
         mov       al,es:[491h]             ; stav mdia disku 1
         or        bl,bl                    ; je disk 0 ?
         jnz       GetMed1                  ; je disk 1
         mov       al,es:[490h]             ; stav mdia disku 0
GetMed1: ret

GetMed   ENDP

; -----------------------------------------------------------------------------
;        Nastaven stavovho bajtu mdia mechaniky AL
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=stav mdia
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetMed
SetMed   PROC      NEAR

         cmp       bl,2                     ; jsou bajty v BIOS-RAM ?
         jb        SetMed2                  ; jsou disky 0 nebo 1

; ------ nastaven disk 2 nebo 3 (vlastn bajty)

         ja        SetMed1                  ; je disk 3
         mov       byte ptr ds:[Med2],al    ; nastaven stavovho bajtu disku 2
         ret

SetMed1: mov       byte ptr ds:[Med3],al    ; nastaven stavovho bajtu disku 3
         ret

; ------ nastaven disku 1

SetMed2: or        bl,bl                    ; je disk 0 ?
         jz        SetMed3                  ; je disk 0
         mov       es:[491h],al             ; nastaven bajtu disku 1
         ret

; ------ nastaven disku 0

SetMed3: mov       es:[490h],al             ; nastaven bajtu disku 0
         ret

SetMed   ENDP

; -----------------------------------------------------------------------------
;        Poskytnut stavovho bajtu disku
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        ES=0
;        DS=CS
; VSTUP:AL=stav disku
;        ZY=disk nen definovn
; -----------------------------------------------------------------------------

PUBLIC   GetStat
GetStat  PROC      NEAR

         mov       al,ds:[Stat3]            ; stav disku 3
         cmp       bl,2                     ; je disk 2 nebo 3 ?
         ja        GetStat1                 ; je disk 3
         mov       al,ds:[Stat2]            ; stav disku 2
         je        GetStat1                 ; je disk 2
         mov       al,es:[48fh]             ; stavov bajt mechnaik
         or        bl,bl                    ; je disk 0 ?
         jz        GetStat1                 ; je disk 0
         shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1                     ; rotace pro disk 1
GetStat1:and       al,7                     ; ponech se sprvn poet bit
         ret

GetStat  ENDP

; -----------------------------------------------------------------------------
;        Nastaven stavovho bajtu disku
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
;        AL=stav disku
;        ES=0
;        DS=CS
; -----------------------------------------------------------------------------

PUBLIC   SetStat
SetStat  PROC      NEAR

         push      ax
         and       al,7                     ; ponechaj se jen sprvn bity
         cmp       bl,2                     ; jsou bajty v BIOS-RAM ?
         jb        SetStat2                 ; jsou disky 0 nebo 1

; ------ nastaven disk 2 nebo 3 (vlastn bajty)

         ja        SetStat1                 ; je disk 3
         mov       byte ptr ds:[Stat2],al   ; nastaven stavovho bajtu disku 2
         jmp       short SetStat5           ; nvrat
SetStat1:mov       byte ptr ds:[Stat3],al   ; nastaven stavovho bajtu disku 3
         jmp       short SetStat5           ; nvrat

; ------ nastaven disku 1

SetStat2:or        bl,bl                    ; je disk 0 ?
         jz        SetStat3                 ; je disk 0
         shl       al,1
         shl       al,1
         shl       al,1
         shl       al,1                     ; rotace pro disk 1 na pozici
         and       byte ptr es:[48fh],not 70h ; zruen starho nastaven
         jmp       short SetStat4           ; nastaven disku 1

; ------ nastaven disku 0

SetStat3:and       byte ptr es:[48fh],not 7 ; zruen starho nastaven disku 0
SetStat4:or        es:[48fh],al             ; nastaven disk 0 nebo 1

SetStat5:pop       ax
         ret

SetStat  ENDP

; -----------------------------------------------------------------------------
;        Poskytnut typu disku
; -----------------------------------------------------------------------------
; VSTUP: BL=poadovan disk
;        DS=CS
; VSTUP:AL=typ disku (0 a 4)
;        ZY=disk nen definovn nebo chyba (AL=0)
; -----------------------------------------------------------------------------

PUBLIC   GetTyp
GetTyp   PROC      NEAR

         push      bx
         xor       bh,bh                    ; BX = poadovan disk
         mov       al,ds:[DefDisk+bx]       ; typ disku
         cmp       al,4                     ; je povolen typ disku ?
         jbe       GetTyp1                  ; povolen slo disku
         xor       al,al                    ; disk nen definovn
GetTyp1: or        al,al                    ; pznak ZY=disk nen definovn
         pop       bx
         ret

GetTyp   ENDP

; -----------------------------------------------------------------------------
;        Poskytnut disketovho parametru AL
; -----------------------------------------------------------------------------
; VSTUP: ES=0
;        BL=slo disku
;        AL=slo parametru (offset v tabulce parametr)
; VSTUP:AL=parametr z tabulky
; -----------------------------------------------------------------------------

PUBLIC   GetPar
GetPar   PROC      NEAR

         push      bx
         push      si
         push      ds
         lds       si,es:[4*1eh]
         xor       bh,bh
         mov       bl,al
         mov       al,ds:[si+bx]
         pop       ds
         pop       si
         pop       bx
         ret

GetPar   ENDP



; *****************************************************************************
;        Obsluhy ekn
; *****************************************************************************


; -----------------------------------------------------------------------------
;        ekn na pipravenost adie
; -----------------------------------------------------------------------------
; VSTUP: BL=disk
;        AH=poadovan stav portu (maskovan 0c0h)
;        DS=CS
; VSTUP:AH=kd chyby (0=operace OK)
;        ZY=operace OK, NZ=chyba operace TIME-OUT
; Znien registry: AL
; -----------------------------------------------------------------------------

PUBLIC   WaitPort
WaitPort PROC      NEAR

         push      dx                       ; schova DX
         mov       byte ptr ds:[Counter],20;10 ; doba asi 1/2 sekundy
         call      GetPrt4                  ; stavov registr adie

; ------ ekn na pipravenost adie

WaitPrt1:in        al,dx                    ; ten stavovho registru adie
         and       al,0c0h                  ; bity pipravenosti
         cmp       al,ah                    ; je adi pipraven ?
         je        WaitPrt2                 ; adi je ji pipraven
         cmp       byte ptr ds:[Counter],0  ; uplynul ji zadan as ?
         jne       WaitPrt1                 ; as jet neuplynul

; ------ pekroen doby - chyba TIME-OUT

         mov       ah,80h                   ; pznak chyby TIME-OUT
         jmp       short WaitPrt3           ; nvrat z obsluhy

; ------ adi je pipraven

WaitPrt2:xor       ah,ah                    ; pznak, e adi je pipraven
WaitPrt3:or        ah,ah                    ; test pznaku chyby
         pop       dx
         ret

WaitPort ENDP

; -----------------------------------------------------------------------------
;        Nepodmnn ekn po zadanou dobu
; -----------------------------------------------------------------------------
; VSTUP: AX=maximln ekac doba (nsobek 30 us)
;        DS=CS
; -----------------------------------------------------------------------------t  

PUBLIC   WaitT
WaitT    PROC      NEAR

         push      cx
         mov       cx,ax                    ; ni slovo tae
WaitT1:  call      Wait0                    ; ekn po dobu 30 mikrosekund
         loop      WaitT1                   ; dal ekn
         pop       cx
         ret

WaitT    ENDP

; -----------------------------------------------------------------------------
;        ekn po dobu 30 us
; -----------------------------------------------------------------------------
; VSTUP: DS=CS
; -----------------------------------------------------------------------------

PUBLIC   Wait0
Wait0    PROC      NEAR

         push      ax

; ------ pokud je XT, je zvltn ekac prodleva

         cmp       byte ptr ds:[TimAT],1    ; je asova AT ?
         je        Wait01                   ; je asova AT
         push      cx

         mov       cx,15                    ; 17 takt = 3.5 us (+ rezerva)

;         mov       cx,6                     ; 17 takt = 3.5 us (+ rezerva)
         loop      $                        ; prodleva pro XT asi 30 us
         pop       cx
         jmp       short Wait03             ; dal test

; ------ ekn na stav 0 signlu hodin

Wait01:  in        al,[61h]                 ; systmov stavov slovo
         test      al,10h                   ; jsou hodiny na rovni 0 ?
         jnz       Wait01                   ; ekn na stav 0 signlu hodin

; ------ ekn na stav 1 signlu hodin

Wait02:  in        al,[61h]                 ; systmov stavov slovo
         test      al,10h                   ; jsou hodiny na rovni 1 ?
         jz        Wait02                   ; ekn na stav 1 signlu hodin

Wait03:  pop       ax
         ret

Wait0    ENDP

; -----------------------------------------------------------------------------
;        Poskytnut adresy portu
; -----------------------------------------------------------------------------
; VSTUP: BL=slo disku
; VSTUP:DX=adresa portu
; -----------------------------------------------------------------------------

PUBLIC   GetPrt2
GetPrt2: mov       dl,2
         jmp       short GetPrt


PUBLIC   GetPrt4
GetPrt4: mov       dl,4
         jmp       short GetPrt


PUBLIC   GetPrt5
GetPrt5: mov       dl,5
         jmp       short GetPrt


PUBLIC   GetPrt7
GetPrt7: mov       dl,7


GetPrt:  xor       dh,dh                    ; DX = offset adresy portu
         cmp       bl,2                     ; je disk 0,1 nebo 2,3 ?
         jb        GetPrt0                  ; jsou disky 0 nebo 1
         add       dx,cs:[AdrPort2]         ; adresa portu 2
         ret

GetPrt0: add       dx,cs:[AdrPort1]         ; adresa portu 1
         ret

; *****************************************************************************
;
;        Instalace programu
;
; *****************************************************************************

Init     PROC      NEAR

                                          ;* vodn text
         mov       dx,offset UvTxt          ; vodn text
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ test, zda je signl hodin (port 61h)

         mov       cx,63230                 ; max. doba testu

; ------ ekn na stav 0 signlu hodin

Init01:  in        al,[61h]                 ; systmov stavov slovo
         test      al,10h                   ; jsou hodiny na rovni 0 ?
         loopnz    Init01                   ; ekn na stav 0 signlu hodin
         jcxz      Init08                   ; nen asova AT

; ------ ekn na stav 1 signlu hodin

Init02:  in        al,[61h]                 ; systmov stavov slovo
         test      al,10h                   ; jsou hodiny na rovni 1 ?
         loopz     Init02                   ; ekn na stav 1 signlu hodin
         jcxz      Init08                   ; nen asova AT

; ------ ekn na stav 0 signlu hodin

Init03:  in        al,[61h]                 ; systmov stavov slovo
         test      al,10h                   ; jsou hodiny na rovni 0 ?
         loopnz    Init03                   ; ekn na stav 0 signlu hodin
         jcxz      Init08                   ; nen asova AT

; ------ ekn na stav 1 signlu hodin

Init04:  in        al,[61h]                 ; systmov stavov slovo
         test      al,10h                   ; jsou hodiny na rovni 1 ?
         loopz     Init04                   ; ekn na stav 1 signlu hodin
         jcxz      Init08                   ; nen asova AT

         mov       byte ptr ds:[TimAt],1    ; pznak asovae AT

Init08:

; ------ test, zda je pota AT

         push      es
         mov       ax,0f000h
         mov       es,ax
         mov       al,es:[0fffeh]           ; identifiktor syst. modelu
         pop       es
         cmp       al,0fch                  ; je AT ?
         ja        Init09                   ; nen AT
         mov       byte ptr ds:[WaitAT],1   ; pznak oznamovn ekn AT

Init09:

                                          ;* dekdovn parametr
         cld                                ; smr nahoru
         mov       si,81h                   ; zatek textu parametr
         mov       di,offset DefDisk        ; tabulka definic disk
         xor       cx,cx                    ; CX <- 0
         mov       cl,ds:[80h]              ; dlka pkazovho dku
Init1:   jcxz      Init3                    ; konec textu
         lodsb                              ; naten znaku parametr
         dec       cx                       ; snen tae znak
         cmp       al,13                    ; je konec textu ?
         je        Init3                    ; je konec textu
         cmp       al," "                   ; je oddlova ?
         jbe       Init1                    ; je oddlova
         cmp       al,","
         je        Init1
         cmp       al,";"
         je        Init1
         cmp       al,"/"
         je        Init1
         sub       al,"0"                   ; korekce znaku na slo
         jc        Init2                    ; nen platn znak
         cmp       al,4
         ja        Init2                    ; nen platn slo typu disku
         stosb                              ; uloen sla disku
         jmp       short Init1              ; dekdovn dalho znaku

Init2:   mov       dx,offset HlpTxt         ; text npovdy
         mov       ah,9
         int       21h                      ; zobrazen textu npovdy
         int       20h                      ; nvrat s chybou

Init3:   cmp       di,offset DefDisk        ; byl nainstalovn njak disk ?
         je        Init2                    ; nebyl zadn dn disk
         cmp       di,offset DefDisk+2      ; bylo zadno vc ne 2 disky ?
         jbe       Init4                    ; byly 2 disky nebo mn
         inc       byte ptr ds:[ParCtr2]    ; pznak instalace adie #2

Init4:
                                          ;* reset disk
         mov       ah,0dh
         int       21h                      ; reset diskovho systmu
         xor       ax,ax
         xor       dx,dx
         int       13h                      ; reset disk

                                          ;* instalace obsluhy INT 40h
         mov       ax,3540h
         int       21h                      ; poskynut adresy obsluhy ITN 40h
         mov       word ptr ds:[Old40],bx   ; offset pvodn obsluhy INT 40h
         mov       word ptr ds:[Old40+2],es ; segment pvodn obsluhy INT 40h
         mov       dx,offset Int40          ; vlastn obsluha INT 40h
         mov       ax,2540h
         int       21h                      ; instalace vlastn obsluhy INT 40h

                                          ;* instalace obsluhy INT 08h
         mov       ax,3508h
         int       21h                      ; poskynut adresy obsluhy ITN 08h
         mov       word ptr ds:[Old08],bx   ; offset pvodn obsluhy INT 08h
         mov       word ptr ds:[Old08+2],es ; segment pvodn obsluhy INT 08h
         mov       dx,offset Int08          ; vlastn obsluha INT 08h
         mov       ax,2508h
         int       21h                      ; instalace vlastn obsluhy INT 08h


         xor       ax,ax
         mov       es,ax                    ; ES <- 0

         mov       bl,0
         call      DrvDet0
         mov       bl,1
         call      DrvDet0
         mov       bl,2
         call      DrvDet0
         mov       bl,3
         call      DrvDet0

;         call      FlopIni                  ; inicializace diskovho systmu



PUBLIC   TestT
TestT:
;         mov       ah,2
;         mov       al,9
;         mov       ch,1
;         mov       cl,1
;         mov       dh,0
;         mov       dl,0
;         push      cs
;         pop       es
;         mov       bx,offset uvtxt
;         int       40h

ifdef    DEBUG
         mov       ax,1701h
         mov       dl,0
         int       13h
         mov       ax,1704h
         mov       dl,0
         int       13h
         mov       ax,1705h
         mov       dl,0
         int       13h
ENDIF


         push      ds
         xor       ax,ax
         mov       ds,ax
         lds       bx,ds:[78h]              ; adresa INT 1eh
         mov       byte ptr ds:[bx+0ah],3   ; as pro sputn motoru
         pop       ds

                                           ;* reset disk po instalaci

         mov       ah,0dh
         int       21h                      ; reset diskovho systmu
         xor       ax,ax
         xor       dx,dx
         int       13h                      ; reset disk
                                          ;* instalace programu
IFNDEF   DEBUG
         mov       dx,offset Init           ; konec rezidentn sti programu
         int       27h                      ; instalace programu
ELSE

PUBLIC   Navrat
Navrat:

         lds       dx,cs:[Old08]            ; offset pvodn obsluhy INT 08h
         mov       ax,2508h
         int       21h                      ; instalace vlastn obsluhy INT 08h

         lds       dx,cs:[Old40]            ; offset pvodn obsluhy INT 40h
         mov       ax,2540h
         int       21h                      ; instalace vlastn obsluhy INT 40h

         int       20h

ENDIF

Init     ENDP



;; -----------------------------------------------------------------------------
;;        Inicializace diskovho systmu
;; -----------------------------------------------------------------------------
;
;PUBLIC   FlopIni
;FlopIni  PROC      NEAR
;
;         pushf
;         push      ax
;         push      bx
;         push      cx
;         push      dx
;         push      si
;         push      di
;         push      bp
;         push      ds
;         push      es
;
;         cld                                ; smr nahoru
;         push      cs
;         pop       ds                       ; DS <- CS
;         xor       ax,ax
;         mov       es,ax                    ; ES <- 0
;
;         lea       di,cs:[43eh]             ; tabulka disketovch parametr
;         mov       cx,11                    ; poet bajt k inicializaci
;         xor       ax,ax                    ; AX <- 0
;         rep       stosb                    ; vymazn systmovch tabulek
;
;         lea       di,cs:[48fh]
;         mov       cx,7
;         rep       stosb
;
;         and       byte ptr es:[48bh],0cch
;         or        byte ptr es:[48bh],88h
;
;         mov       byte ptr es:[48bh],88h
;
;         xor       bl,bl
;         mov       al,2
;         call      GetPrt7
;         out       dx,al
;         mov       bl,2
;         call      GetPrt7
;         out       dx,al
;
;         call      Funkce00                 ; reset diskovho systmu
;
;         mov       bl,0                     ; disk 0
;         call      DrvDet                   ; uren, zda je mechanika 40 stop
;         mov       bl,1                     ; disk 1
;         call      DrvDet                   ; uren, zda je mechanika 40 stop
;         mov       bl,2                     ; disk 2
;         call      DrvDet                   ; uren, zda je mechanika 40 stop
;         mov       bl,3                     ; disk 3
;         call      DrvDet                   ; uren, zda je mechanika 40 stop
;
;         call      Funkce00                 ; reset diskovho systmu
;
;         mov       al,2
;         call      GetPar                   ; poskytnut parametru 2
;         call      SetMOff                  ; nastaven ta pro vypnut mot.
;
;         pop       es
;         pop       ds
;         pop       bp
;         pop       di
;         pop       si
;         pop       dx
;         pop       cx
;         pop       bx
;         pop       ax
;         popf
;
;         ret
;
;FlopIni  ENDP
;
;
;; -----------------------------------------------------------------------------
;;        Uren, zda je mechanika 40 nebo 80 stop
;; -----------------------------------------------------------------------------
;; VSTUP: BL=slo disku
;;        ES=0
;;        DS=CS
;; Znien registry: AX
;; -----------------------------------------------------------------------------
;
;PUBLIC   DrvDet
;DrvDet   PROC      NEAR
;
;         push      cx
;         push      dx
;
;; ------ zapnut motoru
;
;         call      MotorOn                  ; zapnut motoru
;
;; ------ zruen pznaku dvojho krokovn
;
;         call      GetMed                   ; poskytnut bajtu stavu mdia
;         and       al,not 20h               ; nulovn pznaku dvojho krokov.
;         call      SetMed                   ; nastaven bajtu stavu mdia
;
;; ------ nulovn pznaku rekalibrace
;
;         call      NulRec                   ; nulovn pznaku rekalibrace
;
;; ------ vystaven na stopu 50 (mechanika 40 stop se zastav na dorazu)
;
;         xor       dx,dx                    ; pednastaven - nen dn disk
;         mov       al,50                    ; poadovan stopa 50
;         call      Seek                     ; vystaven na stopu 50
;         jnz       DrvDet3                  ; byla chyba vystaven - nen nech.
;
;; ------ nalezen stopy 0
;
;         mov       ch,11                    ; vchoz stopa 10
;DrvDet1: dec       ch                       ; snen sla stopy
;         js        DrvDet2                  ; pekroena stopa 0 - chyba
;         mov       al,ch                    ; poadovan stopa
;         call      Seek                     ; vystaven na poadovanou stopu
;         jnz       DrvDet3                  ; byla chyba operace - nen mech.
;
;; ------ vysln povelu SENSE DRIVE STATUS
;
;         mov       cl,bl                    ; poadovan disk
;         and       cl,1                     ; disk relativn (0 nebo 1)
;         push      cx                       ; poadovan disk
;         mov       si,sp                    ; ukazatel dat v zsobnku
;         mov       al,4                     ; povel SENSE DRIVE STATUS
;         mov       ah,2                     ; poet bajt
;         call      NECOutp                  ; vysln povelu SENSE DRIVE STATUS
;         pop       cx                       ; nvrat poadovanho disku
;         jnz       DrvDet3                  ; chyba operace
;
;; ------ test vsledku operace - zda bylo dosaeno stopy 0
;
;         call      Result                   ; pjem vsledku operace
;         jnz       DrvDet3                  ; byla chyba operace
;         xor       al,al                    ; parametr 0 - registr ST3
;         call      GetRes                   ; poskytnut registru 3
;         test      al,10h                   ; bylo dosaeno stopy 0 ?
;         jz        DrvDet1                  ; stopa 0 nenalezena - dal
;
;; ------ nalezena stopa 0 - rozlien mechaniky podle sla stopy
;
;DrvDet2: mov       dl,1                     ; pznaky - je 80 stop
;         mov       dh,2                     ; stavov bajt - 1.2 MB v 1.2 MB
;         or        ch,ch                    ; byla stopa 0 ?
;         jz        DrvDet3                  ; byla stopa 0 - je mech. 80 stop
;         mov       dl,4                     ; pznaky - uren mech. 40 stop
;         mov       dh,93h                   ; stavov bajt - 360 KB v 360 KB
;         call      NulRec                   ; vyaduje se opt rekalibrace
;
;; ------ nastaven zjitnho typu mechaniky a inic. typu mdia
;
;DrvDet3: mov       al,dh                    ; inicializan typ mdia
;         call      SetMed                   ; nastaven bajtu stavu mdia
;         mov       al,dl                    ; typ mechaniky
;         call      SetStat                  ; nastaven stavovho bajtu disku
;
;         pop       dx
;         pop       cx
;         ret
;
;DrvDet   ENDP
;

; ------ uren typu mdia podle CMOS (pi inicializaci)

DrvDet0:; push      cx
        ; push      dx
         xor       dx,dx                    ; pednastaven - dn disk
         call      GetTyp                   ; poskytnut typu disku AL
         jz        DrvDet3                  ; nen dn disk
         mov       dx,9304h                 ; parametry pro mechaniku 360 KB
         cmp       al,1                     ; je mechanika 360 KB ?
         je        DrvDet3                  ; je mechanika 360 KB
         mov       dx,201h                  ; parametry pro jin mechaniky
;         jmp       short DrvDet3            ; je jin mechanika

; ------ nastaven zjitnho typu mechaniky a inic. typu mdia

DrvDet3: mov       al,dh                    ; inicializan typ mdia
         call      SetMed                   ; nastaven bajtu stavu mdia
         mov       al,dl                    ; typ mechaniky
         call      SetStat                  ; nastaven stavovho bajtu disku

        ; pop       dx
        ; pop       cx
         ret


UvTxt    db        'FLOPPY V1.20 - ovladac pruznych disku; (c) Miroslav Nemecek',13,10,'$'

HlpTxt   db        13,10,'Zadejte cisla typu mechanik (max. 4 mechaniky):',13,10
         db        '        0 - mechanika nenainstalovana',13,10
         db        '        1 - 360 KB (5 1/4", 40 stop, 300 ot./min.)',13,10
         db        '        2 - 1.2 MB (5 1/4", 80 stop, 360 ot./min.)',13,10
         db        '        3 - 720 KB (5 1/4", 80 stop, 300 ot./min.)',13,10
         db        '            720 KB (3 1/2", 80 stop, 300 ot./min.)',13,10
         db        '        4 - 1.44 MB (3 1/2", 80 stop, 300 ot./min.)',13,10
         db        13,10
         db        '$'

code     ENDS
         END       start
